# Accessibility
Accessibility (A11y) is very important to the HAX community. Because the project was founded at Pennsylvania State University, we try and stick to the accessibility requirements the university has aligned with. At the time of this writing, the university requires we work toward the [WCAG 2.0 AA](https://www.w3.org/TR/WCAG20/) standard established by the W3C.

## Methods
If you have issues with any aspect of HAX associated with accessibility please report it in our [issue queue](https://github.com/elmsln/haxcms/issues). We use various tools and techniques to ensure compliance including (but not limited to):
- Automated testing for build quality
- Aligning with Google produced web components (heavily vetted for accessibility)
- Using the WAVE browser plugin to check accessibility while building
- Lighthouse testing periodically
- Human testing with and without screen readers