define(["exports", "../../../@polymer/polymer/polymer-element.js"], function (_exports, _polymerElement) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.AgencyThemeSpotlight = void 0;

  function _templateObject_d52a1060e53211e9a0cfefb808989d41() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <style>\n        :host {\n          --agency-theme-spotlight-image-height: 10em;\n          --agency-theme-spotlight-content-padding: 3vw;\n          --agency-theme-spotlight-content-color: white;\n          display: block;\n          color: white;\n        }\n\n        :host([hidden]) {\n          display: none;\n        }\n\n        .inner {\n          display: flex;\n          flex-wrap: wrap;\n        }\n\n        .image {\n          display: flex;\n          width: 100%;\n          flex: 0 1 auto;\n          justify-content: center;\n        }\n\n        .image img {\n          border-radius: 100%;\n          object-fit: cover;\n          width: var(--agency-theme-spotlight-image-height);\n          height: var(--agency-theme-spotlight-image-height);\n        }\n\n        @media screen and (min-width: 500px) {\n          .inner {\n            flex-wrap: nowrap;\n          }\n          .image {\n            width: auto;\n          }\n          .image + .content {\n            margin-left: var(--agency-theme-spotlight-content-padding);\n          }\n        }\n\n        .content {\n          width: 100%;\n          flex: 1 1 auto;\n          -ms-flex: 2;\n        }\n        .title {\n          border-bottom: 1px solid rgba(0, 0, 0, 0.2);\n          margin-bottom: 1em;\n          @apply --agency-theme-spotlight-margin;\n        }\n      </style>\n      <div class=\"inner\">\n        <div class=\"image\">\n          <img src=\"[[image]]\" alt=\"\" />\n        </div>\n        <div class=\"content\">\n          <div class=\"title\"><slot name=\"title\"></slot></div>\n          <slot></slot>\n        </div>\n      </div>\n    "]);

    _templateObject_d52a1060e53211e9a0cfefb808989d41 = function _templateObject_d52a1060e53211e9a0cfefb808989d41() {
      return data;
    };

    return data;
  }

  /**
   * `agency-theme-body`
   * `HAX theme to present an agency style site.`
   *
   * @microcopy - language worth noting:
   *  -
   *
   * @customElement
   * @polymer
   * @demo demo/index.html
   */
  var AgencyThemeSpotlight =
  /*#__PURE__*/
  function (_PolymerElement) {
    babelHelpers.inherits(AgencyThemeSpotlight, _PolymerElement);

    function AgencyThemeSpotlight() {
      babelHelpers.classCallCheck(this, AgencyThemeSpotlight);
      return babelHelpers.possibleConstructorReturn(this, babelHelpers.getPrototypeOf(AgencyThemeSpotlight).apply(this, arguments));
    }

    babelHelpers.createClass(AgencyThemeSpotlight, [{
      key: "connectedCallback",

      /**
       * life cycle, element is afixed to the DOM
       */
      value: function connectedCallback() {
        babelHelpers.get(babelHelpers.getPrototypeOf(AgencyThemeSpotlight.prototype), "connectedCallback", this).call(this);
      } // render function

    }], [{
      key: "tag",

      /**
       * Store the tag name to make it easier to obtain directly.
       * @notice function name must be here for tooling to operate correctly
       */
      get: function get() {
        return "agency-theme-spotlight";
      }
    }, {
      key: "properties",
      get: function get() {
        return {
          image: {
            type: String
          }
        };
      }
    }, {
      key: "template",
      get: function get() {
        return (0, _polymerElement.html)(_templateObject_d52a1060e53211e9a0cfefb808989d41());
      }
    }]);
    return AgencyThemeSpotlight;
  }(_polymerElement.PolymerElement);

  _exports.AgencyThemeSpotlight = AgencyThemeSpotlight;
  window.customElements.define(AgencyThemeSpotlight.tag, AgencyThemeSpotlight);
});