define(["exports", "../../../@polymer/polymer/polymer-element.js", "../../../@polymer/iron-icons/iron-icons.js", "../../../@polymer/paper-icon-button/paper-icon-button.js", "../../../@polymer/paper-input/paper-input.js", "../../simple-colors/simple-colors.js"], function (_exports, _polymerElement, _ironIcons, _paperIconButton, _paperInput, _simpleColors) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.EditableListItem = void 0;

  function _templateObject_d6e52de0e53211e9a0cfefb808989d41() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <style include=\"simple-colors-shared-styles\">\n        :host {\n          display: block;\n        }\n\n        :host([hidden]) {\n          display: none;\n        }\n        :host([can-edit]) #edit {\n          visibility: visible;\n          opacity: 1;\n        }\n        :host([can-delete]) #delete {\n          visibility: visible;\n          opacity: 1;\n        }\n        :host #add,\n        #duplicate {\n          visibility: visible;\n          opacity: 1;\n        }\n        paper-icon-button {\n          visibility: hidden;\n          opacity: 0;\n          transition: 0.3s all linear;\n        }\n        paper-input {\n          --paper-input-container-shared-input-style: {\n            height: 40px;\n            padding: 0;\n            margin: 0;\n          }\n        }\n        .input {\n          display: block;\n          height: 40px;\n          padding: 0;\n          margin: 0;\n          line-height: 40px;\n        }\n        .input[hidden] {\n          display: none;\n        }\n        div.input {\n          z-index: 1;\n        }\n        .ops {\n          position: absolute;\n          display: block;\n          right: 0;\n          top: 0;\n          z-index: 2;\n          background-color: white;\n        }\n        .ops paper-icon-button {\n          border-radius: 50%;\n          height: 32px;\n          width: 32px;\n          padding: 4px;\n          margin: 0px;\n        }\n        .ops[hidden] {\n          display: none;\n        }\n        #edit {\n          color: white;\n          background-color: var(--simple-colors-default-theme-green-8, #ddffdd);\n        }\n        #delete {\n          color: white;\n          background-color: var(--simple-colors-default-theme-red-6, #ff5555);\n        }\n      </style>\n      <paper-input\n        id=\"input\"\n        class=\"input\"\n        value=\"{{value}}\"\n        hidden$=\"[[!editing]]\"\n      ></paper-input>\n      <div class=\"input\" hidden$=\"[[editing]]\">[[value]]</div>\n      <div class=\"ops\" hidden$=\"[[!editMode]]\">\n        <paper-icon-button\n          on-click=\"_editToggle\"\n          id=\"edit\"\n          icon=\"icons:create\"\n        ></paper-icon-button>\n        <paper-icon-button\n          on-click=\"_editToggle\"\n          id=\"add\"\n          icon=\"icons:add\"\n        ></paper-icon-button>\n        <paper-icon-button\n          on-click=\"_editToggle\"\n          id=\"duplicate\"\n          icon=\"icons:content-copy\"\n        ></paper-icon-button>\n        <paper-icon-button\n          on-click=\"_deleteModal\"\n          id=\"delete\"\n          icon=\"icons:delete\"\n        ></paper-icon-button>\n      </div>\n    "]);

    _templateObject_d6e52de0e53211e9a0cfefb808989d41 = function _templateObject_d6e52de0e53211e9a0cfefb808989d41() {
      return data;
    };

    return data;
  }

  /**
   * `editable-list-item`
   * `an individual list item`
   *
   * @microcopy - language worth noting:
   *  - an item is a thing in a list of many which can be modified
   *
   * @customElement
   * @polymer
   * @demo demo/index.html
   */
  var EditableListItem =
  /*#__PURE__*/
  function (_PolymerElement) {
    babelHelpers.inherits(EditableListItem, _PolymerElement);

    function EditableListItem() {
      babelHelpers.classCallCheck(this, EditableListItem);
      return babelHelpers.possibleConstructorReturn(this, babelHelpers.getPrototypeOf(EditableListItem).apply(this, arguments));
    }

    babelHelpers.createClass(EditableListItem, [{
      key: "connectedCallback",

      /**
       * life cycle, element is afixed to the DOM
       */
      value: function connectedCallback() {
        babelHelpers.get(babelHelpers.getPrototypeOf(EditableListItem.prototype), "connectedCallback", this).call(this);
      }
      /**
       * life cycle, element is removed from the DOM
       */
      //disconnectedCallback() {}

    }, {
      key: "_editToggle",
      value: function _editToggle(e) {
        this.editing = !this.editing;

        if (this.editing) {
          this.$.input.focus();
        }
      }
      /**
       * Generate a modal to delete this item, parent has to handle that though
       */

    }, {
      key: "_deleteModal",
      value: function _deleteModal(e) {
        var evt = new CustomEvent("editable-list-item-delete", {
          bubbles: true,
          cancelable: true,
          detail: {
            element: this
          }
        });
        this.dispatchEvent(evt);
      } // Observer editMode for changes

    }, {
      key: "_editModeChanged",
      value: function _editModeChanged(newValue, oldValue) {
        if (babelHelpers.typeof(newValue) !== (typeof undefined === "undefined" ? "undefined" : babelHelpers.typeof(undefined))) {
          if (newValue) {
            this.$.edit.icon = "icons:save";
          } else {
            this.$.edit.icon = "icons:create";
          }
        }
      }
    }], [{
      key: "template",
      // render function
      get: function get() {
        return (0, _polymerElement.html)(_templateObject_d6e52de0e53211e9a0cfefb808989d41());
      } // properties available to the custom element for data binding

    }, {
      key: "properties",
      get: function get() {
        return {
          /**
           * The value that gets bound into the text field
           */
          value: {
            name: "value",
            type: String
          },

          /**
           * ability to edit the items in the list
           */
          editMode: {
            name: "editMode",
            type: Boolean,
            value: false,
            notify: true,
            reflectToAttribute: true
          },

          /**
           * Editing state of the item
           */
          editing: {
            name: "editing",
            type: Boolean,
            value: false,
            observer: "_editModeChanged"
          },

          /**
           * Permission to edit this
           */
          canEdit: {
            name: "canEdit",
            type: Boolean,
            value: false,
            reflectToAttribute: true
          },

          /**
           * Permission to delete this
           */
          canDelete: {
            name: "canDelete",
            type: Boolean,
            value: false,
            reflectToAttribute: true
          }
        };
      }
      /**
       * Store the tag name to make it easier to obtain directly.
       * @notice function name must be here for tooling to operate correctly
       */

    }, {
      key: "tag",
      get: function get() {
        return "editable-list-item";
      }
    }]);
    return EditableListItem;
  }(_polymerElement.PolymerElement);

  _exports.EditableListItem = EditableListItem;
  window.customElements.define(EditableListItem.tag, EditableListItem);
});