define(["exports", "../../../../@polymer/polymer/polymer-element.js", "../../../../@polymer/paper-styles/color.js", "../../../../@polymer/paper-styles/typography.js"], function (_exports, _polymerElement, _color, _typography) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.PaperChip = void 0;

  function _templateObject_fcd12040e53211e9a0cfefb808989d41() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <style>\n        :host {\n          display: inline-block;\n          background-color: var(--paper-chip-background, var(--paper-grey-300));\n          height: 32px;\n          line-height: 32px !important;\n          padding: 0 12px;\n          border-radius: 16px;\n          color: var(--paper-chip-color, var(--primary-text-color));\n          font-size: 13px !important;\n          @apply --paper-font-body1;\n          @apply --paper-chip;\n        }\n        :host([selectable]) {\n          cursor: pointer;\n        }\n        :host([selectable]:hover) {\n          background-color: var(\n            --paper-chip-background-selectable,\n            var(--paper-grey-400)\n          );\n        }\n      </style>\n      <slot></slot>\n    "]);

    _templateObject_fcd12040e53211e9a0cfefb808989d41 = function _templateObject_fcd12040e53211e9a0cfefb808989d41() {
      return data;
    };

    return data;
  }

  /**
  A material design [chip](https://www.google.com/design/spec/components/chips.html)
  ### Example
  ```html
  <paper-chip>Apples</paper-chip>
  ```
  ### Styling
  The following custom properties and mixins are available for styling:
  Custom property | Description | Default
  ----------------|-------------|----------
  `--paper-chip-background` | The background color of the chip | `--paper-grey-300`
  `--paper-chip-background-selectable` | The background color hover of the chip | `--paper-grey-600`
  `--paper-chip-color` | The text color | `--primary-text-color`
  `--paper-chip-color-selectable` | The text color hover of the chip | `white`
  @demo demo/chip.html
  */
  var PaperChip =
  /*#__PURE__*/
  function (_PolymerElement) {
    babelHelpers.inherits(PaperChip, _PolymerElement);

    function PaperChip() {
      babelHelpers.classCallCheck(this, PaperChip);
      return babelHelpers.possibleConstructorReturn(this, babelHelpers.getPrototypeOf(PaperChip).apply(this, arguments));
    }

    babelHelpers.createClass(PaperChip, null, [{
      key: "template",
      get: function get() {
        return (0, _polymerElement.html)(_templateObject_fcd12040e53211e9a0cfefb808989d41());
      }
    }, {
      key: "tag",
      get: function get() {
        return "paper-chip";
      }
    }, {
      key: "properties",
      get: function get() {
        return {
          selectable: {
            type: Boolean,
            value: false,
            reflectToAttribute: true
          }
        };
      }
    }]);
    return PaperChip;
  }(_polymerElement.PolymerElement);

  _exports.PaperChip = PaperChip;
  window.customElements.define(PaperChip.tag, PaperChip);
});