define(["exports", "../../../../@polymer/polymer/polymer-element.js", "../../../../@polymer/polymer/lib/elements/dom-if.js", "../../../../@polymer/iron-ajax/iron-ajax.js", "../../../../@polymer/paper-toast/paper-toast.js", "../../../lrnsys-button/lrnsys-button.js"], function (_exports, _polymerElement, _domIf, _ironAjax, _paperToast, _lrnsysButton) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.LrnappStudioProjectButton = void 0;

  function _templateObject_03106650e53311e9a0cfefb808989d41() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <style>\n        :host {\n          display: block;\n        }\n      </style>\n      <template is=\"dom-if\" if=\"[[createProjectsUrl]]\">\n        <lrnsys-button\n          raised=\"\"\n          class$=\"[[classes]]\"\n          button-class$=\"[[classes]]\"\n          icon=\"[[icon]]\"\n          on-click=\"_createProject\"\n          label=\"Create project\"\n        ></lrnsys-button>\n        <iron-ajax\n          id=\"ajaxCreateStub\"\n          url=\"[[createProjectsUrl]]\"\n          method=\"POST\"\n          handle-as=\"json\"\n          on-response=\"_ajaxCreateStubHandler\"\n        ></iron-ajax>\n      </template>\n      <template is=\"dom-if\" if=\"[[displayErrors]]\">\n        <paper-toast id=\"toast\"></paper-toast>\n      </template>\n    "], ["\n      <style>\n        :host {\n          display: block;\n        }\n      </style>\n      <template is=\"dom-if\" if=\"[[createProjectsUrl]]\">\n        <lrnsys-button\n          raised=\"\"\n          class\\$=\"[[classes]]\"\n          button-class\\$=\"[[classes]]\"\n          icon=\"[[icon]]\"\n          on-click=\"_createProject\"\n          label=\"Create project\"\n        ></lrnsys-button>\n        <iron-ajax\n          id=\"ajaxCreateStub\"\n          url=\"[[createProjectsUrl]]\"\n          method=\"POST\"\n          handle-as=\"json\"\n          on-response=\"_ajaxCreateStubHandler\"\n        ></iron-ajax>\n      </template>\n      <template is=\"dom-if\" if=\"[[displayErrors]]\">\n        <paper-toast id=\"toast\"></paper-toast>\n      </template>\n    "]);

    _templateObject_03106650e53311e9a0cfefb808989d41 = function _templateObject_03106650e53311e9a0cfefb808989d41() {
      return data;
    };

    return data;
  }

  /*
  `lrnapp-studio-project-button`
  Allows users to create new projects.
  
  Usage:
  ```
  <lrnapp-studio-project-button classes="amber white-text" icon="add" display-errors="true" end-point="[[endPoint]]" csrf-token=[[csrfToken]]></lrnapp-studio-project-button>
  */
  var LrnappStudioProjectButton =
  /*#__PURE__*/
  function (_PolymerElement) {
    babelHelpers.inherits(LrnappStudioProjectButton, _PolymerElement);

    function LrnappStudioProjectButton() {
      babelHelpers.classCallCheck(this, LrnappStudioProjectButton);
      return babelHelpers.possibleConstructorReturn(this, babelHelpers.getPrototypeOf(LrnappStudioProjectButton).apply(this, arguments));
    }

    babelHelpers.createClass(LrnappStudioProjectButton, [{
      key: "ready",
      value: function ready() {
        babelHelpers.get(babelHelpers.getPrototypeOf(LrnappStudioProjectButton.prototype), "ready", this).call(this);
        this.createProjectsUrl = this.endPoint + "/api/projects/create-stub?token=" + this.csrfToken;
      }
    }, {
      key: "_createProject",
      value: function _createProject() {
        this.shadowRoot.querySelector("#ajaxCreateStub").generateRequest();
      }
    }, {
      key: "_ajaxCreateStubHandler",
      value: function _ajaxCreateStubHandler(e) {
        var status = e.detail.response.status;
        var response = e.detail.response;

        if (status === 201) {
          var project = e.detail.response.data;

          if (project) {
            this.dispatchEvent(new CustomEvent("project-created", {
              bubbles: true,
              cancelable: true,
              composed: true,
              detail: {
                project: project
              }
            }));
          }
        } // if we have errors to display


        if (typeof response.errors !== "undefined") {
          var ul = document.createElement("ul");
          var text = "";
          response.errors.forEach(function (error) {
            text = text + " " + error;
          });
          this.shadowRoot.querySelector("#toast").show(text);
        }
      }
    }], [{
      key: "template",
      get: function get() {
        return (0, _polymerElement.html)(_templateObject_03106650e53311e9a0cfefb808989d41());
      }
    }, {
      key: "tag",
      get: function get() {
        return "lrnapp-studio-project-button";
      }
    }, {
      key: "properties",
      get: function get() {
        return {
          elmslnCourse: {
            type: String
          },
          elmslnSection: {
            type: String
          },
          basePath: {
            type: String
          },
          csrfToken: {
            type: String
          },
          endPoint: {
            type: String
          },
          auto: {
            type: Boolean,
            reflectToAttribute: true,
            value: false,
            notify: true
          },
          displayErrors: {
            type: Boolean,
            value: true
          },
          createProjectsUrl: {
            type: String,
            value: null
          },
          classes: {
            type: String,
            value: ""
          },
          icon: {
            type: String,
            value: ""
          }
        };
      }
    }]);
    return LrnappStudioProjectButton;
  }(_polymerElement.PolymerElement);

  _exports.LrnappStudioProjectButton = LrnappStudioProjectButton;
  window.customElements.define(LrnappStudioProjectButton.tag, LrnappStudioProjectButton);
});