define(["exports", "../../@polymer/polymer/polymer-element.js"], function (_exports, _polymerElement) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.FullWidthImage = void 0;

  function _templateObject_84a9d940e53211e9a0cfefb808989d41() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <style>\n        :host {\n          display: block;\n          background-color: #000000;\n          height: 300px;\n          margin: 0 !important;\n          padding: 0 !important;\n        }\n\n        :host([hidden]) {\n          display: none;\n        }\n\n        #image {\n          left: 0;\n          right: 0;\n          position: absolute;\n          background-repeat: no-repeat;\n          background-position: center center;\n          background-size: cover;\n          width: 100%;\n          text-align: center;\n        }\n\n        :host([hax-preview-mode]) #image {\n          left: unset;\n          right: unset;\n          position: unset;\n        }\n\n        .wrapper {\n          opacity: 1;\n          background-color: rgba(0, 0, 0, 0.6);\n          padding: 100px;\n          height: 100px;\n          transition: 0.5s all ease-in-out;\n          -webkit-transition: 0.5s all ease-in-out;\n          -moz-transition: 0.5s all ease-in-out;\n          -ms-transition: 0.5s all ease-in-out;\n          -o-transition: 0.5s all ease-in-out;\n        }\n        .wrapper:hover {\n          opacity: 0;\n          background-color: transparent;\n        }\n\n        .caption {\n          padding: 35px 0;\n          font-size: 25px;\n          line-height: 40px;\n          color: #fff;\n          font-style: italic;\n        }\n      </style>\n      <div id=\"image\">\n        <div class=\"wrapper\">\n          <div class=\"caption\">\n            [[caption]]\n            <slot></slot>\n          </div>\n        </div>\n      </div>\n    "]);

    _templateObject_84a9d940e53211e9a0cfefb808989d41 = function _templateObject_84a9d940e53211e9a0cfefb808989d41() {
      return data;
    };

    return data;
  }

  /**
   * `full-width-image`
   * `full width image that flows beyond boundaries`
   *
   * @microcopy - language worth noting:
   *  - images are best used when stretched across content
   *
   * @customElement
   * @polymer
   * @demo demo/index.html
   */
  var FullWidthImage =
  /*#__PURE__*/
  function (_PolymerElement) {
    babelHelpers.inherits(FullWidthImage, _PolymerElement);

    function FullWidthImage() {
      babelHelpers.classCallCheck(this, FullWidthImage);
      return babelHelpers.possibleConstructorReturn(this, babelHelpers.getPrototypeOf(FullWidthImage).apply(this, arguments));
    }

    babelHelpers.createClass(FullWidthImage, [{
      key: "_sourceChanged",
      // Observer source for changes
      value: function _sourceChanged(newValue, oldValue) {
        if (babelHelpers.typeof(newValue) !== (typeof undefined === "undefined" ? "undefined" : babelHelpers.typeof(undefined))) {
          this.$.image.style.backgroundImage = "url(\"".concat(newValue, "\")");
        }
      }
    }], [{
      key: "template",
      // render function
      get: function get() {
        return (0, _polymerElement.html)(_templateObject_84a9d940e53211e9a0cfefb808989d41());
      } // haxProperty definition

    }, {
      key: "haxProperties",
      get: function get() {
        return {
          canScale: false,
          canPosition: false,
          canEditSource: false,
          gizmo: {
            title: "Full width-image",
            description: "full width image that flows beyond boundaries",
            icon: "image:image",
            color: "green",
            groups: ["Width"],
            handles: [{
              type: "image",
              source: "source",
              caption: "caption",
              title: "caption"
            }],
            meta: {
              author: "btopro",
              owner: "The Pennsylvania State University"
            }
          },
          settings: {
            quick: [{
              property: "source",
              description: "",
              inputMethod: "textfield",
              required: true,
              icon: "image:image",
              validationType: "url"
            }],
            configure: [{
              property: "source",
              description: "",
              inputMethod: "haxupload",
              required: true,
              icon: "icons:link",
              validationType: "url"
            }, {
              property: "caption",
              description: "",
              inputMethod: "textfield"
            }],
            advanced: []
          }
        };
      } // properties available to the custom element for data binding

    }, {
      key: "properties",
      get: function get() {
        var props = {
          source: {
            name: "source",
            type: String,
            reflectToAttributes: true,
            observer: "_sourceChanged"
          },
          caption: {
            name: "caption",
            type: String,
            reflectToAttributes: true
          }
        };

        if (babelHelpers.get(babelHelpers.getPrototypeOf(FullWidthImage), "properties", this)) {
          props = Object.assign(props, babelHelpers.get(babelHelpers.getPrototypeOf(FullWidthImage), "properties", this));
        }

        return props;
      }
      /**
       * Store the tag name to make it easier to obtain directly.
       * @notice function name must be here for tooling to operate correctly
       */

    }, {
      key: "tag",
      get: function get() {
        return "full-width-image";
      }
    }]);
    return FullWidthImage;
  }(_polymerElement.PolymerElement);

  _exports.FullWidthImage = FullWidthImage;
  window.customElements.define("full-width-image", FullWidthImage);
});