define(["exports", "require", "../../../@polymer/polymer/polymer-element.js", "../../../@polymer/polymer/lib/utils/render-status.js", "../../../@polymer/polymer/lib/utils/async.js", "../../simple-colors/simple-colors.js", "../../grafitto-filter/grafitto-filter.js", "../../../@polymer/iron-list/iron-list.js", "./hax-shared-styles.js"], function (_exports, _require, _polymerElement, _renderStatus, _async, _simpleColors, _grafittoFilter, _ironList, _haxSharedStyles) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.HaxGizmoBrowser = void 0;
  _require = babelHelpers.interopRequireWildcard(_require);

  function _templateObject_def3b5b0e53211e9a0cfefb808989d41() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <style>\n        :host {\n          display: block;\n        }\n        hax-gizmo-browser-item {\n          margin: 10px;\n          -webkit-transition: 0.3s all linear;\n          transition: 0.3s all linear;\n        }\n        #ironlist {\n          min-height: 50vh;\n          margin: 0;\n          padding: 16px;\n        }\n        .title {\n          position: relative;\n          padding: 16px;\n          outline: 0;\n          font-weight: 600;\n          text-align: left;\n          margin: 0;\n          font-size: 18px;\n          line-height: 18px;\n          font-family: \"Noto Serif\", serif;\n          background-color: var(--hax-color-menu-heading-bg, #eeeeee);\n          color: var(--hax-color-menu-heading-color, black);\n        }\n        .toolbar-inner {\n          display: inline-flex;\n          padding: 10px;\n        }\n      </style>\n      <h3 class=\"title\">[[title]]</h3>\n      <div class=\"toolbar-inner\">\n        <dropdown-select id=\"filtertype\" label=\"Filter by\" value=\"title\">\n          <paper-item value=\"title\">Title</paper-item>\n        </dropdown-select>\n        <paper-input\n          label=\"Filter\"\n          id=\"inputfilter\"\n          aria-controls=\"filter\"\n          value=\"\"\n          always-float-label=\"\"\n        ></paper-input>\n      </div>\n      <grafitto-filter\n        id=\"filter\"\n        items=\"[[__gizmoList]]\"\n        like=\"\"\n        where=\"title\"\n        as=\"filtered\"\n      >\n        <template>\n          <iron-list id=\"ironlist\" items=\"[[filtered]]\" as=\"gizmo\" grid>\n            <template>\n              <div class=\"gizmo-container\">\n                <hax-gizmo-browser-item\n                  index=\"[[gizmo.index]]\"\n                  title=\"[[gizmo.title]]\"\n                  tag-to-insert=\"[[gizmo.tag]]\"\n                  icon=\"[[gizmo.icon]]\"\n                  image=\"[[gizmo.image]]\"\n                  color=\"[[gizmo.color]]\"\n                  author=\"[[gizmo.author]]\"\n                  teaser=\"[[gizmo.teaser]]\"\n                  description=\"[[gizmo.description]]\"\n                  examples=\"[[gizmo.examples]]\"\n                  status=\"[[gizmo.status]]\"\n                ></hax-gizmo-browser-item>\n              </div>\n            </template>\n          </iron-list>\n        </template>\n      </grafitto-filter>\n    "]);

    _templateObject_def3b5b0e53211e9a0cfefb808989d41 = function _templateObject_def3b5b0e53211e9a0cfefb808989d41() {
      return data;
    };

    return data;
  }

  /**
   * `hax-gizmo-browser`
   * `Browse a list of gizmos. This provides a listing of custom elements for people to search and select based on what have been defined as gizmos for users to select.`
   * @microcopy - the mental model for this element
   * - gizmo - silly name for the general public when talking about custom elements and what it provides in the end.
   */
  var HaxGizmoBrowser =
  /*#__PURE__*/
  function (_PolymerElement) {
    babelHelpers.inherits(HaxGizmoBrowser, _PolymerElement);

    function HaxGizmoBrowser() {
      var _this;

      babelHelpers.classCallCheck(this, HaxGizmoBrowser);
      _this = babelHelpers.possibleConstructorReturn(this, babelHelpers.getPrototypeOf(HaxGizmoBrowser).call(this));
      new Promise(function (res, rej) {
        return _require.default(["../../../@polymer/paper-input/paper-input.js"], res, rej);
      });
      new Promise(function (res, rej) {
        return _require.default(["../../dropdown-select/dropdown-select.js"], res, rej);
      });
      new Promise(function (res, rej) {
        return _require.default(["./hax-gizmo-browser-item.js"], res, rej);
      });
      return _this;
    }

    babelHelpers.createClass(HaxGizmoBrowser, [{
      key: "ready",

      /**
       * life cycle
       */
      value: function ready() {
        babelHelpers.get(babelHelpers.getPrototypeOf(HaxGizmoBrowser.prototype), "ready", this).call(this);
        this.resetBrowser();
        (0, _renderStatus.afterNextRender)(this, function () {
          var _this2 = this;

          this.shadowRoot.querySelector("#inputfilter").addEventListener("value-changed", function (e) {
            _this2.shadowRoot.querySelector("#filter").like = e.target.value;
          });
          this.shadowRoot.querySelector("#filtertype").addEventListener("change", function (e) {
            _this2.shadowRoot.querySelector("#inputfilter").value = "";
            _this2.shadowRoot.querySelector("#filter").where = e.detail.value;
            _this2.shadowRoot.querySelector("#filter").like = "";
          });
          document.body.addEventListener("hax-store-property-updated", this._haxStorePropertyUpdated.bind(this));
        });
      }
      /**
       * Store updated, sync.
       */

    }, {
      key: "_haxStorePropertyUpdated",
      value: function _haxStorePropertyUpdated(e) {
        if (e.detail && babelHelpers.typeof(e.detail.value) !== (typeof undefined === "undefined" ? "undefined" : babelHelpers.typeof(undefined)) && e.detail.property) {
          this.set(e.detail.property, e.detail.value);
        }
      }
      /**
       * Reset this browser.
       */

    }, {
      key: "resetBrowser",
      value: function resetBrowser() {
        var _this3 = this;

        if (babelHelpers.typeof(this.shadowRoot.querySelector("#filter")) !== (typeof undefined === "undefined" ? "undefined" : babelHelpers.typeof(undefined))) {
          _async.microTask.run(function () {
            _this3.set("__gizmoList", window.HaxStore.instance.gizmoList);

            if (_this3.shadowRoot.querySelector("#filter").shadowRoot.querySelector("#ironlist")) {
              _this3.shadowRoot.querySelector("#filter").shadowRoot.querySelector("#ironlist").filtered = _this3.__gizmoList;
            }

            _this3.shadowRoot.querySelector("#inputfilter").value = "";
            _this3.shadowRoot.querySelector("#filtertype").value = "title";
            _this3.shadowRoot.querySelector("#filter").value = "";

            _this3.shadowRoot.querySelector("#filter").filter();

            _this3.shadowRoot.querySelector("#filter").where = "title";
            _this3.shadowRoot.querySelector("#filter").like = "";
            setTimeout(function () {
              if (_this3.shadowRoot.querySelector("#filter").shadowRoot.querySelector("#ironlist")) {
                _this3.shadowRoot.querySelector("#filter").shadowRoot.querySelector("#ironlist").dispatchEvent(new CustomEvent("iron-resize", {
                  bubbles: true,
                  cancelable: true,
                  composed: true,
                  detail: true
                }));

                window.dispatchEvent(new Event("resize"));
              }
            }, 100);
          });
        }
      }
    }], [{
      key: "template",
      get: function get() {
        return (0, _polymerElement.html)(_templateObject_def3b5b0e53211e9a0cfefb808989d41());
      }
    }, {
      key: "tag",
      get: function get() {
        return "hax-gizmo-browser";
      }
    }, {
      key: "properties",
      get: function get() {
        return {
          /**
           * Search term
           */
          search: {
            type: String
          },

          /**
           * Title of the browser, for translation.
           */
          title: {
            type: String,
            value: "Make"
          }
        };
      }
    }]);
    return HaxGizmoBrowser;
  }(_polymerElement.PolymerElement);

  _exports.HaxGizmoBrowser = HaxGizmoBrowser;
  window.customElements.define(HaxGizmoBrowser.tag, HaxGizmoBrowser);
});