define(["exports", "../../../lit-element/lit-element.js", "../../../@polymer/paper-button/paper-button.js", "../../../@polymer/paper-tooltip/paper-tooltip.js", "../../../@polymer/iron-icon/iron-icon.js"], function (_exports, _litElement, _paperButton, _paperTooltip, _ironIcon) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.HAXPanelItem = void 0;

  function _templateObject2_df47c920e53211e9a0cfefb808989d41() {
    var data = babelHelpers.taggedTemplateLiteral(["\n        :host {\n          display: inline-flex;\n        }\n        paper-button {\n          height: 48px;\n          line-height: 48px;\n          width: 48px;\n          overflow: hidden;\n          margin: 0;\n          text-transform: none;\n          background-color: var(--hax-panel-item-bg);\n          color: var(--hax-panel-item-text);\n          display: flex;\n          padding: 8px;\n          border-radius: 50%;\n          border: 1px solid var(--hax-panel-item-border-color);\n          min-width: unset;\n          --paper-button-ink-color: var(--hax-panel-item-ink, black);\n        }\n        paper-button .button-inner {\n          text-align: center;\n          margin: 0 auto;\n        }\n        paper-button iron-icon {\n          height: 24px;\n          width: 24px;\n          display: inline-flex;\n        }\n        paper-button:hover,\n        paper-button:focus {\n          color: var(--hax-panel-item-active);\n          border: 1px solid var(--hax-panel-item-active-border-color);\n        }\n\n        paper-button[disabled] {\n          opacity: 0.5;\n        }\n        .flip-icon {\n          transform: rotateY(180deg);\n        }\n        :host([dark]) paper-button {\n          border: solid 2px #000000;\n          background-color: #000000 !important;\n          color: var(--hax-color-bg-accent);\n        }\n        :host([large]) paper-button {\n          height: 40px;\n          width: 40px;\n        }\n        :host([dark]) paper-button:hover iron-icon,\n        :host([dark]) paper-button:focus iron-icon {\n          color: #ffffff !important;\n        }\n        :host([dark]) paper-button:hover {\n          border: solid #0085ba 1px;\n        }\n        paper-tooltip {\n          --paper-tooltip-background: #000000;\n          --paper-tooltip-opacity: 1;\n          --paper-tooltip-text-color: #ffffff;\n          --paper-tooltip-delay-in: 0;\n          --paper-tooltip: {\n            border-radius: 0;\n          }\n        }\n      "]);

    _templateObject2_df47c920e53211e9a0cfefb808989d41 = function _templateObject2_df47c920e53211e9a0cfefb808989d41() {
      return data;
    };

    return data;
  }

  function _templateObject_df47c920e53211e9a0cfefb808989d41() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <paper-button raised id=\"button\" .disabled=\"", "\">\n        <div class=\"button-inner\">\n          <iron-icon icon=\"", "\"></iron-icon>\n        </div>\n      </paper-button>\n      <paper-tooltip\n        animation-delay=\"0\"\n        for=\"button\"\n        position=\"bottom\"\n        offset=\"10\"\n      >\n        ", "\n      </paper-tooltip>\n    "]);

    _templateObject_df47c920e53211e9a0cfefb808989d41 = function _templateObject_df47c920e53211e9a0cfefb808989d41() {
      return data;
    };

    return data;
  }

  /**
   * `hax-panel-item`
   * `A single button in the hax panel for consistency.`
   * @microcopy - the mental model for this element
   * - panel - the flyout from left or right side that has elements that can be placed
   * - button - an item that expresses what interaction you will have with the content.
   */
  var HAXPanelItem =
  /*#__PURE__*/
  function (_LitElement) {
    babelHelpers.inherits(HAXPanelItem, _LitElement);

    function HAXPanelItem() {
      var _this;

      babelHelpers.classCallCheck(this, HAXPanelItem);
      _this = babelHelpers.possibleConstructorReturn(this, babelHelpers.getPrototypeOf(HAXPanelItem).call(this));
      _this.disabled = false;
      _this.edged = "";
      _this.icon = "editor:text-fields";
      _this.label = "editor:text-fields";
      _this.eventName = "button";
      _this.value = "";
      return _this;
    }

    babelHelpers.createClass(HAXPanelItem, [{
      key: "render",
      value: function render() {
        return (0, _litElement.html)(_templateObject_df47c920e53211e9a0cfefb808989d41(), this.disabled, this.icon, this.label);
      }
    }, {
      key: "connectedCallback",
      value: function connectedCallback() {
        babelHelpers.get(babelHelpers.getPrototypeOf(HAXPanelItem.prototype), "connectedCallback", this).call(this);
        this.addEventListener("click", this._fireEvent);
      }
      /**
       * Fire an event that includes the eventName of what was just pressed.
       */

    }, {
      key: "_fireEvent",
      value: function _fireEvent(e) {
        this.dispatchEvent(new CustomEvent("hax-item-selected", {
          bubbles: true,
          cancelable: false,
          composed: true,
          detail: {
            target: this,
            value: this.value,
            eventName: this.eventName
          }
        }));
      }
    }], [{
      key: "properties",
      get: function get() {
        return {
          /**
           * Variant on button style for light
           */
          light: {
            type: Boolean,
            reflect: true
          },

          /**
           * Voice command to append for things that support data-voicecommand.
           */
          voiceCommand: {
            type: String,
            attribute: "voice-command"
          },

          /**
           * Support for disabled state buttons
           */
          disabled: {
            type: Boolean
          },

          /**
           * If we should apply a rounded edge to the button, opposite
           * to the direction that it's came from.
           */
          edged: {
            type: String,
            reflect: true
          },

          /**
           * Icon for the button.
           */
          icon: {
            type: String,
            reflect: true
          },

          /**
           * Label for the button.
           */
          label: {
            type: String,
            reflect: true
          },

          /**
           * Name of the event to bubble up as being tapped.
           * This can be used to tell other elements what was
           * clicked so it can take action appropriately.
           */
          eventName: {
            type: String,
            reflect: true,
            attribute: "event-name"
          },

          /**
           * Possible value to send along as well with the event.
           * Can help with normalized event names / selection of
           * options.
           */
          value: {
            type: String,
            reflect: true
          }
        };
      }
    }, {
      key: "tag",
      get: function get() {
        return "hax-panel-item";
      }
    }, {
      key: "styles",
      get: function get() {
        return [(0, _litElement.css)(_templateObject2_df47c920e53211e9a0cfefb808989d41())];
      }
    }]);
    return HAXPanelItem;
  }(_litElement.LitElement);

  _exports.HAXPanelItem = HAXPanelItem;
  customElements.define(HAXPanelItem.tag, HAXPanelItem);
});