define(["exports", "../../../../@polymer/polymer/polymer-element.js", "../../../../@vaadin/router/dist/vaadin-router.js", "../../../../mobx/lib/mobx.module.js", "./haxcms-site-store.js"], function (_exports, _polymerElement, _vaadinRouter, _mobxModule, _haxcmsSiteStore) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.HAXCMSSiteRouter = void 0;

  function _templateObject_f9d71a20e53211e9a0cfefb808989d41() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <slot></slot>\n    "]);

    _templateObject_f9d71a20e53211e9a0cfefb808989d41 = function _templateObject_f9d71a20e53211e9a0cfefb808989d41() {
      return data;
    };

    return data;
  }

  /**
   * `haxcms-site-router`
   * `front-end router for haxcms`
   */
  var HAXCMSSiteRouter =
  /*#__PURE__*/
  function (_PolymerElement) {
    babelHelpers.inherits(HAXCMSSiteRouter, _PolymerElement);
    babelHelpers.createClass(HAXCMSSiteRouter, null, [{
      key: "tag",

      /**
       * Store the tag name to make it easier to obtain directly.
       * @notice function name must be here for tooling to operate correctly
       */
      get: function get() {
        return "haxcms-site-router";
      } // render function

    }, {
      key: "template",
      get: function get() {
        return (0, _polymerElement.html)(_templateObject_f9d71a20e53211e9a0cfefb808989d41());
      }
    }, {
      key: "properties",
      get: function get() {
        return {
          baseURI: {
            type: String
          }
        };
      }
      /**
       * ready life cycle
       */

    }]);

    function HAXCMSSiteRouter() {
      var _this;

      babelHelpers.classCallCheck(this, HAXCMSSiteRouter);
      _this = babelHelpers.possibleConstructorReturn(this, babelHelpers.getPrototypeOf(HAXCMSSiteRouter).call(this)); // create router

      var options = {};

      if (_this.baseURI) {
        options.baseUrl = _this.baseURI;
      }

      _this.router = new _vaadinRouter.Router(babelHelpers.assertThisInitialized(_this), options);
      /**
       * Subscribe to changes in the manifest
       */

      _this.__disposer = (0, _mobxModule.autorun)(function () {
        _this._updateRouter(_haxcmsSiteStore.store.routerManifest);
      });
      window.addEventListener("vaadin-router-location-changed", _this._routerLocationChanged.bind(babelHelpers.assertThisInitialized(_this)));
      return _this;
    }
    /**
     * Detached life cycle
     */


    babelHelpers.createClass(HAXCMSSiteRouter, [{
      key: "disconnectedCallback",
      value: function disconnectedCallback() {
        this.__disposer();

        window.removeEventListener("vaadin-router-location-changed", this._routerLocationChanged.bind(this));
        babelHelpers.get(babelHelpers.getPrototypeOf(HAXCMSSiteRouter.prototype), "disconnectedCallback", this).call(this);
      }
      /**
       * Update the router based on a manifest.
       * This should not be called directly. Use the
       * 'haxcms-router-manifest-changed' event
       *
       * @param {object} routerManifest
       */

    }, {
      key: "_updateRouter",
      value: function _updateRouter(routerManifest) {
        if (!routerManifest || typeof routerManifest.items === "undefined") return;
        var routerItems = routerManifest.items.map(function (i) {
          return {
            path: i.location,
            name: i.id,
            component: "fake-".concat(i.id, "-e")
          };
        });
        this.router.setRoutes([].concat(babelHelpers.toConsumableArray(routerItems), [{
          path: "/",
          component: "fake-home-e",
          name: "home"
        }, {
          path: "/(.*)",
          component: "fake-404-e",
          name: "404"
        }]));
      }
      /**
       * React to page changes in the vaadin router and convert it
       * to a change in the mobx store.
       * @param {event} e
       */

    }, {
      key: "_routerLocationChanged",
      value: function _routerLocationChanged(e) {
        // store local state
        _haxcmsSiteStore.store.location = e.detail.location;
      }
    }]);
    return HAXCMSSiteRouter;
  }(_polymerElement.PolymerElement);

  _exports.HAXCMSSiteRouter = HAXCMSSiteRouter;
  window.customElements.define(HAXCMSSiteRouter.tag, HAXCMSSiteRouter);
});