define(["exports", "../../../../../@polymer/polymer/polymer-element.js", "../../core/haxcms-site-store.js", "../../../../../mobx/lib/mobx.module.js"], function (_exports, _polymerElement, _haxcmsSiteStore, _mobxModule) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.SiteActiveTitle = void 0;

  function _templateObject_0efc9d80e53311e9a0cfefb808989d41() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <style>\n        :host {\n          display: block;\n          transition: 0.2s opacity linear;\n          opacity: 1;\n        }\n        :host([edit-mode]) {\n          opacity: 0.2;\n        }\n        h2 {\n          text-rendering: optimizelegibility;\n          font-family: sans-serif;\n          color: var(--site-active-title-color, #383f45);\n          @apply --site-active-title-heading;\n        }\n      </style>\n      <h2>[[__title]]</h2>\n    "]);

    _templateObject_0efc9d80e53311e9a0cfefb808989d41 = function _templateObject_0efc9d80e53311e9a0cfefb808989d41() {
      return data;
    };

    return data;
  }

  /**
   * `site-active-title`
   * `Title of the active page in the site`
   *
   * @customElement
   * @polymer
   * @demo demo/index.html
   */
  var SiteActiveTitle =
  /*#__PURE__*/
  function (_PolymerElement) {
    babelHelpers.inherits(SiteActiveTitle, _PolymerElement);

    function SiteActiveTitle() {
      babelHelpers.classCallCheck(this, SiteActiveTitle);
      return babelHelpers.possibleConstructorReturn(this, babelHelpers.getPrototypeOf(SiteActiveTitle).apply(this, arguments));
    }

    babelHelpers.createClass(SiteActiveTitle, [{
      key: "_makeTitle",
      value: function _makeTitle(dynamicMethodology, activeTitle, parentTitle, ancestorTitle) {
        switch (dynamicMethodology) {
          case "above":
            if (parentTitle === "" && !this.noFallback) {
              return activeTitle;
            }

            return parentTitle;
            break;

          case "ancestor":
            if (ancestorTitle === "" && !this.noFallback) {
              return activeTitle;
            }

            return ancestorTitle;
            break;

          default:
            return activeTitle;
            break;
        }
      }
    }, {
      key: "connectedCallback",
      value: function connectedCallback() {
        var _this = this;

        babelHelpers.get(babelHelpers.getPrototypeOf(SiteActiveTitle.prototype), "connectedCallback", this).call(this);
        this.__disposer = [];
        (0, _mobxModule.autorun)(function (reaction) {
          _this.editMode = (0, _mobxModule.toJS)(_haxcmsSiteStore.store.editMode);

          _this.__disposer.push(reaction);
        });
        (0, _mobxModule.autorun)(function (reaction) {
          _this.activeTitle = (0, _mobxModule.toJS)(_haxcmsSiteStore.store.activeTitle);

          _this.__disposer.push(reaction);
        });
        (0, _mobxModule.autorun)(function (reaction) {
          _this.ancestorTitle = (0, _mobxModule.toJS)(_haxcmsSiteStore.store.ancestorTitle);

          _this.__disposer.push(reaction);
        });
        (0, _mobxModule.autorun)(function (reaction) {
          _this.parentTitle = (0, _mobxModule.toJS)(_haxcmsSiteStore.store.parentTitle);

          _this.__disposer.push(reaction);
        });
      }
    }, {
      key: "disconnectedCallback",
      value: function disconnectedCallback() {
        // clean up state
        for (var i in this.__disposer) {
          this.__disposer[i].dispose();
        }

        babelHelpers.get(babelHelpers.getPrototypeOf(SiteActiveTitle.prototype), "disconnectedCallback", this).call(this);
      }
    }], [{
      key: "tag",

      /**
       * Store the tag name to make it easier to obtain directly.
       * @notice function name must be here for tooling to operate correctly
       */
      get: function get() {
        return "site-active-title";
      } // render function

    }, {
      key: "template",
      get: function get() {
        return (0, _polymerElement.html)(_templateObject_0efc9d80e53311e9a0cfefb808989d41());
      }
      /**
       * Props
       */

    }, {
      key: "properties",
      get: function get() {
        return {
          /**
           * Turn off the title fallback to avoid empty titles
           */
          noFallback: {
            type: Boolean,
            value: false
          },

          /**
           * How we should obtain the parent who's children we should show
           * options are active, parent, or ancestor
           */
          dynamicMethodology: {
            type: String,
            value: "active"
          },
          __title: {
            type: String,
            computed: "_makeTitle(dynamicMethodology, activeTitle, parentTitle, ancestorTitle)"
          },
          editMode: {
            type: Boolean,
            reflectToAttribute: true
          }
        };
      }
    }]);
    return SiteActiveTitle;
  }(_polymerElement.PolymerElement);

  _exports.SiteActiveTitle = SiteActiveTitle;
  window.customElements.define(SiteActiveTitle.tag, SiteActiveTitle);
});