define(["exports", "require", "../../@polymer/polymer/polymer-element.js"], function (_exports, _require, _polymerElement) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.ImageInspector = void 0;
  _require = babelHelpers.interopRequireWildcard(_require);

  function _templateObject_cfcfac10e53211e9a0cfefb808989d41() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <style>\n        :host {\n          display: block;\n          --image-inspector-background: #dddddd;\n        }\n\n        app-toolbar {\n          width: 90%;\n          background: var(--image-inspector-background);\n          margin: 32px auto;\n          z-index: 1;\n          display: flex;\n          text-align: center;\n          justify-content: space-evenly;\n        }\n\n        lrnsys-button {\n          display: inline-flex;\n        }\n\n        .top {\n          top: 128px;\n        }\n      </style>\n\n      <app-toolbar>\n        <lrnsys-button\n          alt=\"Zoom in\"\n          icon=\"zoom-in\"\n          on-click=\"zoomIn\"\n          hover-class=\"[[hoverClass]]\"\n        ></lrnsys-button>\n        <lrnsys-button\n          alt=\"Zoom out\"\n          icon=\"zoom-out\"\n          on-click=\"zoomOut\"\n          hover-class=\"[[hoverClass]]\"\n        ></lrnsys-button>\n        <lrnsys-button\n          alt=\"Rotate right\"\n          icon=\"image:rotate-right\"\n          on-click=\"rotateRight\"\n          hover-class=\"[[hoverClass]]\"\n        ></lrnsys-button>\n        <lrnsys-button\n          alt=\"Rotate left\"\n          icon=\"image:rotate-left\"\n          on-click=\"rotateLeft\"\n          hover-class=\"[[hoverClass]]\"\n        ></lrnsys-button>\n        <lrnsys-button\n          alt=\"Mirror image\"\n          icon=\"image:flip\"\n          on-click=\"mirrorImage\"\n          hover-class=\"[[hoverClass]]\"\n        ></lrnsys-button>\n        <lrnsys-button\n          alt=\"Open in new window\"\n          icon=\"launch\"\n          href=\"[[src]]\"\n          target=\"_blank\"\n          hover-class=\"[[hoverClass]]\"\n        ></lrnsys-button>\n        <slot name=\"toolbar\"></slot>\n      </app-toolbar>\n      <img-pan-zoom id=\"img\" src=\"[[src]]\"></img-pan-zoom>\n      <slot></slot>\n    "]);

    _templateObject_cfcfac10e53211e9a0cfefb808989d41 = function _templateObject_cfcfac10e53211e9a0cfefb808989d41() {
      return data;
    };

    return data;
  }

  /**
   * `image-inspector`
   * `Zoom, Rotate, Mirror, Download, and View image`
   *
   * @demo demo/index.html
   */
  var ImageInspector =
  /*#__PURE__*/
  function (_PolymerElement) {
    babelHelpers.inherits(ImageInspector, _PolymerElement);

    function ImageInspector() {
      var _this;

      babelHelpers.classCallCheck(this, ImageInspector);
      _this = babelHelpers.possibleConstructorReturn(this, babelHelpers.getPrototypeOf(ImageInspector).call(this));
      new Promise(function (res, rej) {
        return _require.default(["../../@polymer/app-layout/app-layout.js"], res, rej);
      });
      new Promise(function (res, rej) {
        return _require.default(["../img-pan-zoom/img-pan-zoom.js"], res, rej);
      });
      new Promise(function (res, rej) {
        return _require.default(["../lrnsys-button/lrnsys-button.js"], res, rej);
      });
      new Promise(function (res, rej) {
        return _require.default(["../../@polymer/iron-icons/iron-icons.js"], res, rej);
      });
      new Promise(function (res, rej) {
        return _require.default(["../../@polymer/iron-icons/image-icons.js"], res, rej);
      });
      return _this;
    }

    babelHelpers.createClass(ImageInspector, [{
      key: "connectedCallback",
      value: function connectedCallback() {
        babelHelpers.get(babelHelpers.getPrototypeOf(ImageInspector.prototype), "connectedCallback", this).call(this);
        this.__img = this.shadowRoot.querySelector("#img");
      }
      /**
       * Rotate the image to the right.
       */

    }, {
      key: "rotateRight",
      value: function rotateRight() {
        // spin 90
        this.degrees += 90;
        this.__img.style.transform = "rotate(" + this.degrees + "deg)";

        this.__img.toggleClass("top");
      }
      /**
       * Rotate the image to the left.
       */

    }, {
      key: "rotateLeft",
      value: function rotateLeft() {
        // go back 90
        this.degrees += -90;
        this.__img.style.transform = "rotate(" + this.degrees + "deg)";

        this.__img.toggleClass("top");
      }
      /**
       * Flip the image.
       */

    }, {
      key: "mirrorImage",
      value: function mirrorImage() {
        if (this.__img.style.transform === "scaleX(1)") {
          this.__img.style.transform = "scaleX(-1)";
        } else {
          this.__img.style.transform = "scaleX(1)";
        }
      }
      /**
       * Zoom in by calling  downstream function.
       */

    }, {
      key: "zoomIn",
      value: function zoomIn() {
        this.__img.zoomIn();
      }
      /**
       * Zoom out by calling downstream function.
       */

    }, {
      key: "zoomOut",
      value: function zoomOut() {
        this.__img.zoomOut();
      }
    }], [{
      key: "template",
      get: function get() {
        return (0, _polymerElement.html)(_templateObject_cfcfac10e53211e9a0cfefb808989d41());
      }
    }, {
      key: "tag",
      get: function get() {
        return "image-inspector";
      }
    }, {
      key: "properties",
      get: function get() {
        return {
          /**
           * Image rotation
           */
          degrees: {
            type: Number,
            value: 0,
            reflectToAttribute: true
          },

          /**
           * Image source.
           */
          src: {
            type: String,
            reflectToAttribute: true
          },

          /**
           * Hover class for button styling
           */
          hoverClass: {
            type: String,
            value: "blue white-text"
          }
        };
      }
    }]);
    return ImageInspector;
  }(_polymerElement.PolymerElement);

  _exports.ImageInspector = ImageInspector;
  window.customElements.define(ImageInspector.tag, ImageInspector);
});