define(["exports", "require", "../../@polymer/polymer/polymer-element.js", "../schema-behaviors/schema-behaviors.js"], function (_exports, _require, _polymerElement, _schemaBehaviors) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.LrnTable = void 0;
  _require = babelHelpers.interopRequireWildcard(_require);

  function _templateObject_9dd3a6d0e53211e9a0cfefb808989d41() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <style>\n        :host {\n          display: block;\n        }\n        .hidden-title {\n          display: none;\n        }\n      </style>\n      <div typeof=\"oer:SupportingMaterial\">\n        <div class=\"hidden-title\" property=\"oer:name\">[[title]]</div>\n        <div property=\"oer:description\">\n          <slot></slot>\n          <csv-render\n            data-source=\"[[csvFile]]\"\n            caption=\"[[title]]\"\n            summary=\"[[description]]\"\n          ></csv-render>\n        </div>\n      </div>\n    "]);

    _templateObject_9dd3a6d0e53211e9a0cfefb808989d41 = function _templateObject_9dd3a6d0e53211e9a0cfefb808989d41() {
      return data;
    };

    return data;
  }

  /**
   * `lrn-table`
   * `Accessibly render a HTML table from a csv file`
   *
   * @microcopy - language worth noting:
   *  - CSV - Comma separated values
   *
   * @customElement
   * @polymer
   * @polymerLegacy
   * @demo demo/index.html
   */
  var LrnTable =
  /*#__PURE__*/
  function (_SchemaBehaviors) {
    babelHelpers.inherits(LrnTable, _SchemaBehaviors);

    function LrnTable() {
      var _this;

      babelHelpers.classCallCheck(this, LrnTable);
      _this = babelHelpers.possibleConstructorReturn(this, babelHelpers.getPrototypeOf(LrnTable).call(this));
      new Promise(function (res, rej) {
        return _require.default(["../csv-render/csv-render.js"], res, rej);
      });
      return _this;
    }

    babelHelpers.createClass(LrnTable, null, [{
      key: "template",
      get: function get() {
        return (0, _polymerElement.html)(_templateObject_9dd3a6d0e53211e9a0cfefb808989d41());
      }
    }, {
      key: "tag",
      get: function get() {
        return "lrn-table";
      }
    }, {
      key: "properties",
      get: function get() {
        return {
          /**
           * Title of this table. This is both for accessibility and presentation.
           */
          title: {
            type: String
          },

          /**
           * The file to load material from.
           */
          csvFile: {
            type: String
          },

          /**
           * An extended description of the material in the table for improved accessibility.
           */
          description: {
            type: String
          }
        };
      }
      /**
       * Hax properties
       */

    }, {
      key: "haxProperties",
      get: function get() {
        return {
          canScale: true,
          canPosition: true,
          canEditSource: false,
          gizmo: {
            title: "CSV table",
            description: "This can generate a table from a CSV file no matter where it is located.",
            icon: "editor:border-all",
            color: "green",
            groups: ["Presentation", "Table", "Data"],
            handles: [{
              type: "csv",
              source: "csvFile"
            }],
            meta: {
              author: "LRNWebComponents"
            }
          },
          settings: {
            quick: [{
              property: "csvFile",
              title: "Source",
              description: "The URL for this csv file.",
              inputMethod: "textfield",
              icon: "link",
              required: true
            }, {
              property: "title",
              title: "Title",
              description: "Title for the table to be generated.",
              inputMethod: "textfield",
              icon: "editor:title"
            }, {
              property: "description",
              title: "Description",
              description: "More detailed description for improved accessibility of the table data.",
              inputMethod: "textfield",
              icon: "editor:short-text"
            }],
            configure: [{
              property: "csvFile",
              title: "Source",
              description: "The URL for this csv file.",
              inputMethod: "haxupload",
              required: true
            }, {
              property: "title",
              title: "Title",
              description: "Title for the table to be generated.",
              inputMethod: "textfield"
            }, {
              property: "description",
              title: "Description",
              description: "More detailed description for improved accessibility of the table data.",
              inputMethod: "textfield"
            }],
            advanced: []
          }
        };
      }
    }]);
    return LrnTable;
  }((0, _schemaBehaviors.SchemaBehaviors)(_polymerElement.PolymerElement));

  _exports.LrnTable = LrnTable;
  window.customElements.define(LrnTable.tag, LrnTable);
});