define(["exports", "require", "../../@polymer/polymer/polymer-element.js", "../simple-colors/simple-colors.js"], function (_exports, _require, _polymerElement, _simpleColors) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.LrndesignAvatar = void 0;
  _require = babelHelpers.interopRequireWildcard(_require);

  function _templateObject_9ec09ee0e53211e9a0cfefb808989d41() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <style include=\"simple-colors-shared-styles\">\n        :host {\n          display: block;\n        }\n        paper-avatar {\n          color: var(--simple-colors-default-theme-grey-1);\n          background-color: var(--simple-colors-default-theme-accent-8);\n          --paper-avatar-width: var(--lrndesign-avatar-width, 40px);\n          --paper-avatar-height: var(--lrndesign-avatar-height, 40px);\n          --paper-avatar-text-color: var(--simple-colors-default-theme-grey-1);\n        }\n      </style>\n      <paper-avatar\n        label=\"[[label]]\"\n        src=\"[[src]]\"\n        two-chars=\"[[twoChars]]\"\n        style$=\"background-color:[[hexColor]];\"\n        jdenticon=\"[[jdenticon]]\"\n      ></paper-avatar>\n    "]);

    _templateObject_9ec09ee0e53211e9a0cfefb808989d41 = function _templateObject_9ec09ee0e53211e9a0cfefb808989d41() {
      return data;
    };

    return data;
  }

  /**
   * `lrndesign-avatar`
   * `Visualize a user account eitehr with an image, a label, or as abstract art.`
   * @demo demo/index.html
   */
  var LrndesignAvatar =
  /*#__PURE__*/
  function (_SimpleColors) {
    babelHelpers.inherits(LrndesignAvatar, _SimpleColors);

    function LrndesignAvatar() {
      var _this;

      babelHelpers.classCallCheck(this, LrndesignAvatar);
      _this = babelHelpers.possibleConstructorReturn(this, babelHelpers.getPrototypeOf(LrndesignAvatar).call(this));
      new Promise(function (res, rej) {
        return _require.default(["../paper-avatar/paper-avatar.js"], res, rej);
      });
      return _this;
    }

    babelHelpers.createClass(LrndesignAvatar, [{
      key: "_getAccentColor",
      value: function _getAccentColor(color) {
        color = color.replace("-text", "");

        if ((!this.accentColor || this.accentColor === "grey") && this.colors[color]) {
          this.accentColor = color;
        }
      }
    }], [{
      key: "template",
      get: function get() {
        return (0, _polymerElement.html)(_templateObject_9ec09ee0e53211e9a0cfefb808989d41());
      }
    }, {
      key: "tag",
      get: function get() {
        return "lrndesign-avatar";
      }
    }, {
      key: "properties",
      get: function get() {
        return {
          /**
           * text to use for avatar
           */
          label: {
            type: String,
            value: "lrndesign-avatar"
          },

          /**
           * link to an image, optional
           */
          src: {
            type: String
          },

          /**
           * Mode for presenting 1st two letters
           */
          twoChars: {
            type: Boolean,
            value: false
          },

          /**
           * Color class work to apply
           */
          color: {
            type: String,
            value: "blue",
            reflectToAttribute: true,
            observer: "_getAccentColor"
          },

          /**
           * Form abstract art from hash of label
           */
          jdenticon: {
            type: Boolean,
            value: false
          }
        };
      }
    }]);
    return LrndesignAvatar;
  }(_simpleColors.SimpleColors);

  _exports.LrndesignAvatar = LrndesignAvatar;
  window.customElements.define(LrndesignAvatar.tag, LrndesignAvatar);
});