define(["exports", "../../../@polymer/polymer/polymer-element.js", "../../../@polymer/iron-icons/iron-icons.js", "../../../@polymer/iron-icon/iron-icon.js", "../../../@polymer/paper-button/paper-button.js"], function (_exports, _polymerElement, _ironIcons, _ironIcon, _paperButton) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.MapMenuItem = void 0;

  function _templateObject_eb93faa0e53211e9a0cfefb808989d41() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <style>\n        :host {\n          display: block;\n          transition: 0.2s all ease-in-out;\n          transition-delay: 0.2s;\n          font-size: var(--map-menu-item-font-size, 14px);\n          --map-menu-item-height: var(--map-menu-item-height);\n          --map-menu-item-a-color: inherit;\n        }\n        :host([active]) {\n          background: var(--map-menu-active-color);\n          @apply --map-menu-item-active-item;\n        }\n        paper-button {\n          width: 100%;\n          justify-content: left;\n          margin: 0;\n        }\n        iron-icon {\n          display: inline-block;\n          --iron-icon-height: var(--map-menu-item-height);\n        }\n        .title {\n          text-transform: none;\n        }\n        a {\n          color: var(--map-menu-item-a-color);\n          text-decoration: var(--map-menu-item-a-text-decoration);\n        }\n        a,\n        a:hover,\n        a:visited,\n        a:focus {\n          color: var(\n            --map-menu-item-a-active-color,\n            var(--map-menu-item-a-color)\n          );\n          text-decoration: var(--map-menu-item-a-text-decoration);\n        }\n        #track {\n          transition: 0.2s all ease-in-out;\n          transition-delay: 0.5s;\n          position: absolute;\n          right: 0;\n\n          margin-right: 0px;\n          width: 0px;\n          height: 0px;\n          visibility: hidden;\n          opacity: 0;\n        }\n        #track.show-icon {\n          margin-right: 5px;\n          width: 18px;\n          height: 18px;\n          visibility: visible;\n          opacity: 1;\n        }\n        #wrapper {\n          font-size: var(--map-menu-font-size, 16px);\n        }\n      </style>\n      <a tabindex=\"-1\" href$=\"[[url]]\">\n        <paper-button id=\"wrapper\" role=\"link\" noink>\n          <iron-icon hidden$=\"[[__hasIcon(icon)]]\" icon=\"[[icon]]\"></iron-icon>\n          <span class=\"title\">[[title]]</span>\n          <iron-icon\n            id=\"track\"\n            hidden$=\"[[__hasIcon(trackIcon)]]\"\n            icon=\"[[trackIcon]]\"\n          ></iron-icon>\n        </paper-button>\n      </a>\n    "]);

    _templateObject_eb93faa0e53211e9a0cfefb808989d41 = function _templateObject_eb93faa0e53211e9a0cfefb808989d41() {
      return data;
    };

    return data;
  }

  var MapMenuItem =
  /*#__PURE__*/
  function (_PolymerElement) {
    babelHelpers.inherits(MapMenuItem, _PolymerElement);

    function MapMenuItem() {
      babelHelpers.classCallCheck(this, MapMenuItem);
      return babelHelpers.possibleConstructorReturn(this, babelHelpers.getPrototypeOf(MapMenuItem).apply(this, arguments));
    }

    babelHelpers.createClass(MapMenuItem, [{
      key: "_trackIconChanged",
      value: function _trackIconChanged(newValue, oldValue) {
        if (newValue) {
          this.$.track.classList.add("show-icon");
        } else {
          this.$.track.classList.remove("show-icon");
        }
      }
    }, {
      key: "__selectedChanged",
      value: function __selectedChanged(selected, id) {
        if (selected === id) {
          this.dispatchEvent(new CustomEvent("active-item", {
            bubbles: true,
            cancelable: true,
            composed: true,
            detail: this
          }));
        }
      }
    }, {
      key: "_click",
      value: function _click() {
        this.dispatchEvent(new CustomEvent("link-clicked", {
          bubbles: true,
          cancelable: true,
          composed: true,
          detail: {
            id: this.id
          }
        }));
      }
    }, {
      key: "connectedCallback",
      value: function connectedCallback() {
        babelHelpers.get(babelHelpers.getPrototypeOf(MapMenuItem.prototype), "connectedCallback", this).call(this);
        this.dispatchEvent(new CustomEvent("child-attached", {
          bubbles: true,
          cancelable: true,
          composed: true,
          detail: {
            id: this.id
          }
        }));
      }
    }, {
      key: "__hasIcon",
      value: function __hasIcon(icon) {
        return icon || icon === "" ? true : false;
      }
    }], [{
      key: "template",
      get: function get() {
        return (0, _polymerElement.html)(_templateObject_eb93faa0e53211e9a0cfefb808989d41());
      }
    }, {
      key: "tag",
      get: function get() {
        return "map-menu-item";
      }
    }, {
      key: "properties",
      get: function get() {
        var _ref;

        return _ref = {
          icon: {
            type: String,
            value: ""
          },
          trackIcon: {
            stype: String,
            value: "",
            observer: "_trackIconChanged"
          },
          title: {
            type: String,
            value: ""
          },
          url: {
            type: String,
            value: ""
          }
        }, babelHelpers.defineProperty(_ref, "icon", {
          type: String
        }), babelHelpers.defineProperty(_ref, "id", {
          type: String,
          reflectToAttribute: true
        }), babelHelpers.defineProperty(_ref, "active", {
          type: Boolean,
          value: false
        }), babelHelpers.defineProperty(_ref, "selected", {
          type: String
        }), _ref;
      }
    }, {
      key: "observers",
      get: function get() {
        return ["__selectedChanged(selected, id)"];
      }
    }]);
    return MapMenuItem;
  }(_polymerElement.PolymerElement);

  _exports.MapMenuItem = MapMenuItem;
  window.customElements.define(MapMenuItem.tag, MapMenuItem);
});