define(["exports", "require", "../../@polymer/polymer/polymer-element.js", "../simple-colors/simple-colors.js", "../schema-behaviors/schema-behaviors.js", "../a11y-behaviors/a11y-behaviors.js"], function (_exports, _require, _polymerElement, _simpleColors, _schemaBehaviors, _a11yBehaviors) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.SelfCheck = void 0;
  _require = babelHelpers.interopRequireWildcard(_require);

  function _templateObject_c46723d0e53211e9a0cfefb808989d41() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <style include=\"simple-colors-shared-styles\">\n        :host {\n          display: block;\n          margin: 15px 0;\n          --self-check-question-color: var(\n            --simple-colors-default-theme-grey-1,\n            #fff\n          );\n          --self-check-question-text: var(\n            --simple-colors-default-theme-grey-12,\n            #000\n          );\n          --self-check-heading-color: var(\n            --simple-colors-default-theme-accent-8,\n            #444\n          );\n          --self-check-heading-text: var(\n            --simple-colors-default-theme-grey-1,\n            #fff\n          );\n          --self-check-answer-color: var(\n            --simple-colors-default-theme-light-green-8,\n            #00762e\n          );\n          --self-check-answer-text: var(\n            --simple-colors-default-theme-grey-1,\n            #fff\n          );\n        }\n        [hidden] {\n          display: none !important;\n        }\n\n        paper-card {\n          width: 100%;\n          color: var(--self-check-question-text);\n          background-color: var(--self-check-question-color);\n          overflow: hidden;\n        }\n\n        paper-icon-button#checkbtn {\n          width: 50px;\n          height: 50px;\n          position: relative;\n          left: 16px;\n          bottom: -10px;\n        }\n\n        .check_button {\n          display: flex;\n          justify-content: flex-end;\n        }\n\n        paper-icon-button#closeBtn {\n          width: 50px;\n          height: 50px;\n          position: relative;\n          left: 16px;\n          bottom: -16px;\n        }\n\n        .close_button {\n          display: flex;\n          justify-content: flex-end;\n        }\n\n        iron-icon#questionmark {\n          width: 35px;\n          height: 35px;\n          padding: 5px;\n          color: var(--simple-colors-default-theme-grey-1, #fff);\n        }\n\n        .heading {\n          text-transform: uppercase;\n          font-size: 22px;\n          margin: 10px;\n          color: var(--simple-colors-default-theme-grey-1, #fff);\n        }\n\n        #header_wrap {\n          color: var(--self-check-heading-text);\n          background-color: var(--self-check-heading-color);\n          display: inline-flex;\n          width: 100%;\n          margin: -20px 0 0;\n        }\n\n        #question_wrap {\n          color: var(--self-check-question-text);\n          background-color: var(--self-check-question-color);\n          position: relative;\n        }\n\n        .question {\n          font-size: 16px;\n          padding: 15px 15px;\n        }\n\n        :host([correct]) .question {\n          display: none;\n        }\n\n        #answer_wrap {\n          visibility: hidden;\n          opacity: 0;\n          color: var(--self-check-answer-text);\n          background-color: var(--self-check-answer-color);\n          border-top: 2px solid var(--self-check-answer-text);\n          width: 100%;\n          top: 0;\n          transition: all 0.2s ease;\n          left: calc(100%);\n          position: absolute;\n        }\n\n        :host([correct]) #answer_wrap {\n          visibility: visible;\n          opacity: 1;\n          position: relative;\n          left: 0;\n        }\n\n        .answer {\n          font-size: 16px;\n          padding: 15px;\n          line-height: 19.2px;\n        }\n\n        #quote_start {\n          display: inline-flex;\n          transform: rotateY(180deg);\n        }\n\n        #quote_end {\n          display: inline-flex;\n        }\n\n        .triangle {\n          width: 0;\n          height: 0;\n          border-left: 20px solid transparent;\n          border-right: 20px solid transparent;\n          border-bottom: 20px solid var(--self-check-heading-color);\n          position: relative;\n          top: -20px;\n          left: -1px;\n        }\n\n        .more_info {\n          display: inline;\n        }\n\n        .more_info a {\n          color: var(--self-check-answer-text);\n        }\n\n        .more_info a:hover {\n          text-decoration: none;\n        }\n      </style>\n      <paper-card image$=\"[[image]]\" alt$=\"[[alt]]\">\n        <div class=\"triangle\"></div>\n        <div id=\"header_wrap\">\n          <iron-icon id=\"questionmark\" icon=\"icons:help\"></iron-icon>\n          <div class=\"heading\">[[title]]</div>\n        </div>\n        <div id=\"question_wrap\">\n          <div class=\"question\" aria-hidden$=\"[[correct]]\">\n            <slot name=\"question\"></slot>\n            <div class=\"check_button\">\n              <paper-icon-button\n                controls=\"answer_wrap\"\n                aria-label=\"Reveal Answer\"\n                id=\"checkBtn\"\n                icon=\"icons:check-circle\"\n                on-click=\"openAnswer\"\n                noink\n              ></paper-icon-button>\n              <paper-tooltip aria-hidden=\"true\" for=\"checkBtn\" position=\"left\">\n                Reveal Answer\n              </paper-tooltip>\n            </div>\n          </div>\n          <div id=\"answer_wrap\" aria-hidden$=\"[[!correct]]\" aria-live=\"polite\">\n            <div class=\"answer\">\n              <user-action track=\"visibility\">\n                <slot></slot>\n              </user-action>\n              <dom-if if=\"[[link]]\">\n                <template>\n                  <div class=\"more_info\" hidden$=\"[[!link]]\">\n                    <user-action track=\"click\" every\n                      ><a href$=\"[[link]]\" target=\"_blank\"\n                        >More info...</a\n                      ></user-action\n                    >\n                  </div>\n                </template>\n              </dom-if>\n              <div class=\"close_button\">\n                <paper-icon-button\n                  aria-label=\"Close\"\n                  id=\"closeBtn\"\n                  icon=\"icons:close\"\n                  on-click=\"openAnswer\"\n                  noink\n                >\n                </paper-icon-button>\n                <paper-tooltip\n                  aria-hidden=\"true\"\n                  for=\"closeBtn\"\n                  position=\"left\"\n                >\n                  Close\n                </paper-tooltip>\n              </div>\n            </div>\n          </div>\n        </div>\n      </paper-card>\n    "]);

    _templateObject_c46723d0e53211e9a0cfefb808989d41 = function _templateObject_c46723d0e53211e9a0cfefb808989d41() {
      return data;
    };

    return data;
  }

  /**
   * `self-check`
   * @demo demo/index.html
   * @microcopy - the mental model for this element
   * CSS Variables that override accent color:
   * --self-check-question-color //overrides the question background color
   * --self-check-question-text //overrides the question text color
   * --self-check-heading-color //overrides the heading background color
   * --self-check-heading-text //overrides the heading text color
   * --self-check-answer-color //overrides the answer background color
   * --self-check-answer-text //overrides the answer text color
   */
  var SelfCheck =
  /*#__PURE__*/
  function (_SchemaBehaviors) {
    babelHelpers.inherits(SelfCheck, _SchemaBehaviors);

    function SelfCheck() {
      var _this;

      babelHelpers.classCallCheck(this, SelfCheck);
      _this = babelHelpers.possibleConstructorReturn(this, babelHelpers.getPrototypeOf(SelfCheck).call(this));
      new Promise(function (res, rej) {
        return _require.default(["../../@polymer/paper-card/paper-card.js"], res, rej);
      });
      new Promise(function (res, rej) {
        return _require.default(["../../@polymer/paper-icon-button/paper-icon-button.js"], res, rej);
      });
      new Promise(function (res, rej) {
        return _require.default(["../../@polymer/iron-icons/editor-icons.js"], res, rej);
      });
      new Promise(function (res, rej) {
        return _require.default(["../../@polymer/iron-icons/iron-icons.js"], res, rej);
      });
      new Promise(function (res, rej) {
        return _require.default(["../../@polymer/paper-tooltip/paper-tooltip.js"], res, rej);
      });
      return _this;
    }

    babelHelpers.createClass(SelfCheck, [{
      key: "openAnswer",

      /**
       * Property for toggling "checkbtn".
       */
      value: function openAnswer(e) {
        this.correct = !this.correct;
      }
    }, {
      key: "connectedCallback",
      value: function connectedCallback() {
        babelHelpers.get(babelHelpers.getPrototypeOf(SelfCheck.prototype), "connectedCallback", this).call(this);
        new Promise(function (res, rej) {
          return _require.default(["../user-action/user-action.js"], res, rej);
        });
      }
    }], [{
      key: "template",
      get: function get() {
        return (0, _polymerElement.html)(_templateObject_c46723d0e53211e9a0cfefb808989d41());
      }
    }, {
      key: "tag",
      get: function get() {
        return "self-check";
      }
    }, {
      key: "properties",
      get: function get() {
        var props = {
          /**
           * Title.
           */
          title: {
            type: String,
            value: "Self-Check"
          },

          /**
           * Question.
           */
          question: {
            type: String,
            value: ""
          },

          /**
           * Image.
           */
          image: {
            type: String,
            value: "",
            reflectToAttribute: true
          },

          /**
           * Alt text for image.
           */
          alt: {
            type: String,
            value: "",
            reflectToAttribute: true
          },

          /**
           * Link for more information.
           */
          link: {
            type: String,
            reflectToAttribute: true
          },

          /**
           * Property for toggling "checkbtn".
           */
          correct: {
            type: Boolean,
            value: false,
            reflectToAttribute: true
          }
        };

        if (babelHelpers.get(babelHelpers.getPrototypeOf(SelfCheck), "properties", this)) {
          props = Object.assign(props, babelHelpers.get(babelHelpers.getPrototypeOf(SelfCheck), "properties", this));
        }

        return props;
      }
    }, {
      key: "haxProperties",
      get: function get() {
        return {
          canScale: true,
          canPosition: true,
          canEditSource: false,
          gizmo: {
            title: "Self-Check",
            description: "The user will be able to complete a self-check.",
            icon: "icons:check-circle",
            color: "orange",
            groups: ["Image", "Assessment"],
            handles: [{
              type: "image",
              source: "image",
              title: "question",
              description: "answer"
            }],
            meta: {
              author: "LRNWebComponents"
            }
          },
          settings: {
            quick: [{
              property: "title",
              title: "Title",
              description: "The title of the element",
              inputMethod: "textfield",
              icon: "editor:title"
            }, {
              property: "image",
              title: "Image",
              description: "The image of the element",
              inputMethod: "textfield",
              icon: "editor:insert-photo"
            }, {
              property: "link",
              title: "More link",
              description: "Link to additional information",
              inputMethod: "textfield",
              validationType: "url",
              icon: "icons:link"
            }],
            configure: [{
              property: "title",
              title: "Title",
              description: "The title of the element",
              inputMethod: "textfield"
            }, {
              property: "accentColor",
              title: "Accent Color",
              description: "The accent color of the self-check",
              inputMethod: "colorpicker",
              icon: "editor:format-color-fill"
            }, {
              property: "dark",
              title: "Dark Theme",
              description: "Enable Dark Theme",
              inputMethod: "boolean",
              icon: "icons:invert-colors"
            }, {
              property: "image",
              title: "Image",
              description: "The image of the element",
              inputMethod: "haxupload",
              validationType: "url"
            }, {
              property: "link",
              title: "More link",
              description: "Link to additional information",
              inputMethod: "haxupload",
              validationType: "url"
            }, {
              property: "alt",
              title: "Alt Text",
              description: "Add alt text to the image",
              inputMethod: "alt"
            }, {
              slot: "question",
              title: "Question to ask",
              description: "This is where you enter a question for the self-check.",
              inputMethod: "code-editor",
              required: true
            }, {
              slot: "",
              title: "Answer",
              description: "This is where you enter a question for the self-check.",
              inputMethod: "code-editor",
              required: true
            }],
            advanced: []
          }
        };
      }
    }]);
    return SelfCheck;
  }((0, _schemaBehaviors.SchemaBehaviors)((0, _a11yBehaviors.A11yBehaviors)(_simpleColors.SimpleColors)));

  _exports.SelfCheck = SelfCheck;
  window.customElements.define(SelfCheck.tag, SelfCheck);
});