define(["exports", "require", "../../../@polymer/polymer/polymer-element.js", "../../../@polymer/polymer/lib/utils/render-status.js", "../../simple-colors/simple-colors.js"], function (_exports, _require, _polymerElement, _renderStatus, _simpleColors) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.SimpleBlogOverview = void 0;
  _require = babelHelpers.interopRequireWildcard(_require);

  function _templateObject_f404c6b0e53211e9a0cfefb808989d41() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <style includes=\"simple-colors-shared-styles\">\n        :host {\n          display: block;\n          outline: none;\n          text-transform: none;\n        }\n        paper-card {\n          padding: 32px 16px;\n          margin: 0;\n          min-width: unset;\n          width: 100%;\n          background-color: transparent;\n        }\n        .post-title {\n          letter-spacing: -0.32px;\n          font-weight: 700;\n          font-style: normal;\n          display: block;\n          font-size: 28px;\n          line-height: 1.1;\n          margin: 0;\n        }\n        .post-title a {\n          text-decoration: none;\n          color: #333332;\n        }\n        .post-excerpt,\n        simple-datetime {\n          letter-spacing: -0.32px;\n          font-weight: 300;\n          font-style: normal;\n          font-size: 16px;\n          line-height: 1.3;\n          color: var(--simple-colors-default-theme-grey-10);\n        }\n        .post-excerpt p {\n          text-transform: none;\n        }\n        :host([elevation=\"2\"]) .post-excerpt,\n        :host([elevation=\"2\"]) simple-datetime {\n          color: var(--simple-colors-default-theme-grey-12);\n        }\n        .post-meta {\n          font-size: 14px;\n          color: #b3b3b1;\n          line-height: 30px;\n        }\n        a,\n        a:visited,\n        a:hover,\n        a:focus,\n        a:active {\n          color: inherit;\n        }\n      </style>\n\n      <a href$=\"[[link]]\" itemprop=\"url\" title$=\"[[title]]\">\n        <paper-card elevation=\"[[elevation]]\">\n          <article\n            class=\"post\"\n            itemtype=\"http://schema.org/BlogPosting\"\n            role=\"article\"\n          >\n            <div class=\"article-item\">\n              <header class=\"post-header\">\n                <h3 class=\"post-title\" itemprop=\"name\">[[title]]</h3>\n              </header>\n              <section class=\"post-excerpt\" itemprop=\"description\">\n                <p>[[description]]</p>\n              </section>\n              <div class=\"post-meta\">\n                <simple-datetime\n                  format=\"M jS, Y\"\n                  timestamp=\"[[changed]]\"\n                  unix=\"\"\n                ></simple-datetime>\n              </div>\n            </div>\n          </article>\n        </paper-card>\n      </a>\n    "]);

    _templateObject_f404c6b0e53211e9a0cfefb808989d41 = function _templateObject_f404c6b0e53211e9a0cfefb808989d41() {
      return data;
    };

    return data;
  }

  /**
   * `simple-blog-overview`
   * `Overview / preview of the text of the post with title`
   *
   *  @microcopy - the mental model for this element
   *  - this is one post in a listing of many most likely
   *  - a posting has only text preview
   *
   */
  var SimpleBlogOverview =
  /*#__PURE__*/
  function (_PolymerElement) {
    babelHelpers.inherits(SimpleBlogOverview, _PolymerElement);
    babelHelpers.createClass(SimpleBlogOverview, null, [{
      key: "tag",

      /**
       * Store the tag name to make it easier to obtain directly.
       * @notice function name must be here for tooling to operate correctly
       */
      get: function get() {
        return "simple-blog-overview";
      }
    }]);

    function SimpleBlogOverview() {
      var _this;

      babelHelpers.classCallCheck(this, SimpleBlogOverview);
      _this = babelHelpers.possibleConstructorReturn(this, babelHelpers.getPrototypeOf(SimpleBlogOverview).call(this));
      new Promise(function (res, rej) {
        return _require.default(["../../../@polymer/paper-card/paper-card.js"], res, rej);
      });
      new Promise(function (res, rej) {
        return _require.default(["../../simple-datetime/simple-datetime.js"], res, rej);
      });
      return _this;
    } // render function


    babelHelpers.createClass(SimpleBlogOverview, [{
      key: "ready",
      value: function ready() {
        babelHelpers.get(babelHelpers.getPrototypeOf(SimpleBlogOverview.prototype), "ready", this).call(this);
        (0, _renderStatus.afterNextRender)(this, function () {
          this.addEventListener("mousedown", this.tapEventOn.bind(this));
          this.addEventListener("mouseover", this.tapEventOn.bind(this));
          this.addEventListener("mouseout", this.tapEventOff.bind(this));
          this.addEventListener("focusin", this.tapEventOn.bind(this));
          this.addEventListener("focusout", this.tapEventOff.bind(this));
        });
      }
    }, {
      key: "disconnectedCallback",
      value: function disconnectedCallback() {
        this.removeEventListener("mousedown", this.tapEventOn.bind(this));
        this.removeEventListener("mouseover", this.tapEventOn.bind(this));
        this.removeEventListener("mouseout", this.tapEventOff.bind(this));
        this.removeEventListener("focusin", this.tapEventOn.bind(this));
        this.removeEventListener("focusout", this.tapEventOff.bind(this));
        babelHelpers.get(babelHelpers.getPrototypeOf(SimpleBlogOverview.prototype), "disconnectedCallback", this).call(this);
      }
    }, {
      key: "tapEventOn",

      /**
       * special handling for taps on the thing
       */
      value: function tapEventOn(e) {
        this.elevation = 2;
      }
      /**
       * Hover off stop showing the deeper shadow.
       */

    }, {
      key: "tapEventOff",
      value: function tapEventOff(e) {
        this.elevation = 0;
      }
    }], [{
      key: "template",
      get: function get() {
        return (0, _polymerElement.html)(_templateObject_f404c6b0e53211e9a0cfefb808989d41());
      }
    }, {
      key: "properties",
      get: function get() {
        return {
          /**
           * ID of this item, this is used for selection UX when back button hit, leave this here
           */
          itemId: {
            type: String,
            reflectToAttribute: true
          },

          /**
           * Title
           */
          title: {
            type: String
          },

          /**
           * Body of text
           */
          body: {
            type: String
          },

          /**
           * Link referencing the page content.
           */
          link: {
            type: String
          },

          /**
           * timestamp (unix) of last time changed
           */
          changed: {
            type: Number
          },

          /**
           * elevation
           */
          elevation: {
            type: Number,
            value: 0,
            reflectToAttribute: true
          }
        };
      }
    }]);
    return SimpleBlogOverview;
  }(_polymerElement.PolymerElement);

  _exports.SimpleBlogOverview = SimpleBlogOverview;
  window.customElements.define(SimpleBlogOverview.tag, SimpleBlogOverview);
});