define(["exports", "../../../lit-element/lit-element.js", "../simple-fields.js"], function (_exports, _litElement, _simpleFields) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.SimpleFieldsForm = void 0;

  function _templateObject2_f482a940e53211e9a0cfefb808989d41() {
    var data = babelHelpers.taggedTemplateLiteral(["\n        :host {\n          display: block;\n        }\n      "]);

    _templateObject2_f482a940e53211e9a0cfefb808989d41 = function _templateObject2_f482a940e53211e9a0cfefb808989d41() {
      return data;
    };

    return data;
  }

  function _templateObject_f482a940e53211e9a0cfefb808989d41() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <form><simple-fields id=\"fields\" autofocus></simple-fields></form>\n    "]);

    _templateObject_f482a940e53211e9a0cfefb808989d41 = function _templateObject_f482a940e53211e9a0cfefb808989d41() {
      return data;
    };

    return data;
  }

  /**
   * `simple-fields-form`
   * `binding and submission capabilities on top of simple-fields`
   *
   * @customElement
   * @polymer
   * @demo demo/form.html
   */
  var SimpleFieldsForm =
  /*#__PURE__*/
  function (_LitElement) {
    babelHelpers.inherits(SimpleFieldsForm, _LitElement);
    babelHelpers.createClass(SimpleFieldsForm, [{
      key: "render",
      // render function
      value: function render() {
        return (0, _litElement.html)(_templateObject_f482a940e53211e9a0cfefb808989d41());
      }
      /**
       * first update hook; also implies default settings
       */

    }, {
      key: "firstUpdated",
      value: function firstUpdated(changedProperties) {
        var _this2 = this;

        changedProperties.forEach(function (oldValue, propName) {
          // request form when it changes
          if (propName === "loadEndpoint" && _this2.autoload) {
            _this2.loadData();
          }
        });
      }
    }, {
      key: "updated",
      value: function updated(changedProperties) {
        var _this3 = this;

        changedProperties.forEach(function (oldValue, propName) {
          if (_this3.autoload && !_this3.loadResponse && !_this3.loading) {
            if (propName === "loadEndpoint" || propName === "autoload") {
              _this3.loadData();
            }
          } // we have response data from an end point this should create the form


          if (propName === "loadResponse") {
            _this3.shadowRoot.querySelector("#fields").fields = _this3.loadResponse.data.fields;
            _this3.shadowRoot.querySelector("#fields").value = _this3.loadResponse.data.value; // fire event for things to react to about the response

            _this3.dispatchEvent(new CustomEvent("response", {
              bubbles: true,
              composed: true,
              cancelable: false,
              detail: _this3.loadResponse.data
            }));
          }
        });
      }
      /**
       * load data from the end point
       */

    }, {
      key: "loadData",
      value: function loadData() {
        var _this4 = this;

        this.loading = true;
        this.fetchData(this.loadEndpoint, this.method, this.headers, this.body).then(function (data) {
          _this4.loading = false;
          _this4.loadResponse = data;
        });
      }
    }, {
      key: "fetchData",
      value: function () {
        var _fetchData = babelHelpers.asyncToGenerator(
        /*#__PURE__*/
        regeneratorRuntime.mark(function _callee(path, method, headers, body) {
          var response, data;
          return regeneratorRuntime.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  response = {};

                  if (!(method == "GET")) {
                    _context.next = 7;
                    break;
                  }

                  _context.next = 4;
                  return fetch(path, {
                    method: method,
                    headers: headers
                  });

                case 4:
                  response = _context.sent;
                  _context.next = 10;
                  break;

                case 7:
                  _context.next = 9;
                  return fetch(path, {
                    method: method,
                    headers: headers,
                    //make sure to serialize your JSON body
                    body: JSON.stringify(body)
                  });

                case 9:
                  response = _context.sent;

                case 10:
                  _context.next = 12;
                  return response.json();

                case 12:
                  data = _context.sent;
                  return _context.abrupt("return", data);

                case 14:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee);
        }));

        function fetchData(_x, _x2, _x3, _x4) {
          return _fetchData.apply(this, arguments);
        }

        return fetchData;
      }()
    }], [{
      key: "styles",
      get: function get() {
        return [(0, _litElement.css)(_templateObject2_f482a940e53211e9a0cfefb808989d41())];
      }
    }, {
      key: "tag",
      get: function get() {
        return "simple-fields-form";
      }
    }]);

    function SimpleFieldsForm() {
      var _this;

      babelHelpers.classCallCheck(this, SimpleFieldsForm);
      _this = babelHelpers.possibleConstructorReturn(this, babelHelpers.getPrototypeOf(SimpleFieldsForm).call(this));
      _this.method = "POST";
      _this.loading = false;
      _this.autoload = false;
      _this.headers = {
        Accept: "application/json",
        "Content-Type": "application/json"
      };
      _this.body = {};
      return _this;
    }
    /**
     * Submit form values if we have an end point, otherwise return value
     * of the fields as they currently exist.
     */


    babelHelpers.createClass(SimpleFieldsForm, [{
      key: "submit",
      value: function submit() {
        if (this.saveEndpoint) {
          fetch(this.saveEndpoint, {
            method: this.method,
            headers: this.headers,
            //make sure to serialize your JSON body
            body: JSON.stringify(this.shadowRoot.querySelector("#fields").value)
          });
        }

        return this.shadowRoot.querySelector("#fields").value;
      }
      /**
       * Props down
       */

    }], [{
      key: "properties",
      get: function get() {
        return {
          autoload: {
            type: Boolean,
            reflect: true
          },
          loading: {
            type: Boolean,
            reflect: true
          },
          loadEndpoint: {
            type: String,
            attribute: "load-endpoint"
          },
          saveEndpoint: {
            type: String,
            attribute: "save-endpoint"
          },
          method: {
            type: String
          },
          headers: {
            type: Object
          },
          body: {
            type: Object
          },
          loadResponse: {
            type: Object
          }
        };
      }
    }]);
    return SimpleFieldsForm;
  }(_litElement.LitElement);

  _exports.SimpleFieldsForm = SimpleFieldsForm;
  window.customElements.define(SimpleFieldsForm.tag, SimpleFieldsForm);
});