define(["../polymer/polymer-legacy.js", "../paper-styles/shadow.js", "./paper-material-shared-styles.js", "../polymer/lib/legacy/polymer-fn.js", "../polymer/lib/utils/html-tag.js"], function (_polymerLegacy, _shadow, _paperMaterialSharedStyles, _polymerFn, _htmlTag) {
  "use strict";

  function _templateObject_98407f40e53211e9a0cfefb808989d41() {
    var data = babelHelpers.taggedTemplateLiteral(["\n    <style include=\"paper-material-shared-styles\"></style>\n    <style>\n      :host([animated]) {\n        @apply --shadow-transition;\n      }\n      :host {\n        @apply --paper-material;\n      }\n    </style>\n\n    <slot></slot>\n"]);

    _templateObject_98407f40e53211e9a0cfefb808989d41 = function _templateObject_98407f40e53211e9a0cfefb808989d41() {
      return data;
    };

    return data;
  }

  /**
  Material design:
  [Cards](https://www.google.com/design/spec/components/cards.html)
  
  `paper-material` is a container that renders two shadows on top of each other to
  create the effect of a lifted piece of paper.
  
  Example:
  
      <paper-material elevation="1">
        ... content ...
      </paper-material>
  
  @group Paper Elements
  @demo demo/index.html
  */
  (0, _polymerFn.Polymer)({
    _template: (0, _htmlTag.html)(_templateObject_98407f40e53211e9a0cfefb808989d41()),
    is: 'paper-material',
    properties: {
      /**
       * The z-depth of this element, from 0-5. Setting to 0 will remove the
       * shadow, and each increasing number greater than 0 will be "deeper"
       * than the last.
       *
       * @attribute elevation
       * @type number
       * @default 1
       */
      elevation: {
        type: Number,
        reflectToAttribute: true,
        value: 1
      },

      /**
       * Set this to true to animate the shadow when setting a new
       * `elevation` value.
       *
       * @attribute animated
       * @type boolean
       * @default false
       */
      animated: {
        type: Boolean,
        reflectToAttribute: true,
        value: false
      }
    }
  });
});