define(["exports", "../../../@polymer/polymer/polymer-legacy.js", "../../vaadin-text-field/src/vaadin-text-field.js", "../../../@polymer/polymer/lib/utils/html-tag.js", "../../../@polymer/polymer/lib/legacy/polymer.dom.js", "../../../@polymer/polymer/lib/utils/debounce.js", "../../../@polymer/polymer/lib/utils/async.js", "../../../@polymer/polymer/polymer-element.js"], function (_exports, _polymerLegacy, _vaadinTextField, _htmlTag, _polymerDom, _debounce, _async, _polymerElement) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.GridFilterElement = void 0;

  function _templateObject_21397fe0e53311e9a0cfefb808989d41() {
    var data = babelHelpers.taggedTemplateLiteral(["\n    <style>\n      :host {\n        display: inline-flex;\n        max-width: 100%;\n      }\n\n      #filter {\n        width: 100%;\n        box-sizing: border-box;\n      }\n    </style>\n    <slot name=\"filter\">\n      <vaadin-text-field id=\"filter\" value=\"{{value}}\"></vaadin-text-field>\n    </slot>\n"]);

    _templateObject_21397fe0e53311e9a0cfefb808989d41 = function _templateObject_21397fe0e53311e9a0cfefb808989d41() {
      return data;
    };

    return data;
  }

  /**
   * `<vaadin-grid-filter>` is a helper element for the `<vaadin-grid>` that provides out-of-the-box UI controls,
   * and handlers for filtering the grid data.
   *
   * #### Example:
   * ```html
   * <vaadin-grid-column>
   *   <template class="header">
   *     <vaadin-grid-filter path="name.first"></vaadin-grid-filter>
   *   </template>
   *   <template>[[item.name.first]]</template>
   * </vaadin-grid-column>
   * ```
   *
   * @memberof Vaadin
   */
  var GridFilterElement =
  /*#__PURE__*/
  function (_ref) {
    babelHelpers.inherits(GridFilterElement, _ref);

    function GridFilterElement() {
      babelHelpers.classCallCheck(this, GridFilterElement);
      return babelHelpers.possibleConstructorReturn(this, babelHelpers.getPrototypeOf(GridFilterElement).apply(this, arguments));
    }

    babelHelpers.createClass(GridFilterElement, [{
      key: "connectedCallback",

      /** @protected */
      value: function connectedCallback() {
        babelHelpers.get(babelHelpers.getPrototypeOf(GridFilterElement.prototype), "connectedCallback", this).call(this);
        this._connected = true;
      }
    }, {
      key: "ready",
      value: function ready() {
        babelHelpers.get(babelHelpers.getPrototypeOf(GridFilterElement.prototype), "ready", this).call(this);
        var child = (0, _polymerDom.dom)(this).firstElementChild;

        if (child && child.getAttribute('slot') !== 'filter') {
          console.warn('Make sure you have assigned slot="filter" to the child elements of <vaadin-grid-filter>');
          child.setAttribute('slot', 'filter');
        }
      }
    }, {
      key: "_filterChanged",
      value: function _filterChanged(path, value, connected) {
        var _this = this;

        if (path === undefined || value === undefined || !connected) {
          return;
        }

        if (this._previousValue === undefined && value === '') {
          return;
        }

        this._previousValue = value;
        this._debouncerFilterChanged = _debounce.Debouncer.debounce(this._debouncerFilterChanged, _async.timeOut.after(200), function () {
          _this.dispatchEvent(new CustomEvent('filter-changed', {
            bubbles: true
          }));
        });
      }
    }, {
      key: "focus",
      value: function focus() {
        this.$.filter.focus();
      }
    }], [{
      key: "template",
      get: function get() {
        return (0, _htmlTag.html)(_templateObject_21397fe0e53311e9a0cfefb808989d41());
      }
    }, {
      key: "is",
      get: function get() {
        return 'vaadin-grid-filter';
      }
    }, {
      key: "properties",
      get: function get() {
        return {
          /**
           * JS Path of the property in the item used for filtering the data.
           */
          path: String,

          /**
           * Current filter value.
           */
          value: {
            type: String,
            notify: true
          },
          _connected: Boolean
        };
      }
    }, {
      key: "observers",
      get: function get() {
        return ['_filterChanged(path, value, _connected)'];
      }
    }]);
    return GridFilterElement;
  }(
  /*#__PURE__*/
  function (_PolymerElement) {
    babelHelpers.inherits(_class, _PolymerElement);

    function _class() {
      babelHelpers.classCallCheck(this, _class);
      return babelHelpers.possibleConstructorReturn(this, babelHelpers.getPrototypeOf(_class).apply(this, arguments));
    }

    return _class;
  }(_polymerElement.PolymerElement));

  _exports.GridFilterElement = GridFilterElement;
  customElements.define(GridFilterElement.is, GridFilterElement);
});