define(["exports", "./lib/default-template-processor.js", "./lib/template-result.js", "./lib/directive.js", "./lib/dom.js", "./lib/part.js", "./lib/parts.js", "./lib/render.js", "./lib/template-factory.js", "./lib/template-instance.js", "./lib/template.js"], function (_exports, _defaultTemplateProcessor, _templateResult, _directive, _dom, _part, _parts, _render, _templateFactory, _templateInstance, _template) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  Object.defineProperty(_exports, "DefaultTemplateProcessor", {
    enumerable: true,
    get: function get() {
      return _defaultTemplateProcessor.DefaultTemplateProcessor;
    }
  });
  Object.defineProperty(_exports, "defaultTemplateProcessor", {
    enumerable: true,
    get: function get() {
      return _defaultTemplateProcessor.defaultTemplateProcessor;
    }
  });
  Object.defineProperty(_exports, "SVGTemplateResult", {
    enumerable: true,
    get: function get() {
      return _templateResult.SVGTemplateResult;
    }
  });
  Object.defineProperty(_exports, "TemplateResult", {
    enumerable: true,
    get: function get() {
      return _templateResult.TemplateResult;
    }
  });
  Object.defineProperty(_exports, "directive", {
    enumerable: true,
    get: function get() {
      return _directive.directive;
    }
  });
  Object.defineProperty(_exports, "isDirective", {
    enumerable: true,
    get: function get() {
      return _directive.isDirective;
    }
  });
  Object.defineProperty(_exports, "removeNodes", {
    enumerable: true,
    get: function get() {
      return _dom.removeNodes;
    }
  });
  Object.defineProperty(_exports, "reparentNodes", {
    enumerable: true,
    get: function get() {
      return _dom.reparentNodes;
    }
  });
  Object.defineProperty(_exports, "noChange", {
    enumerable: true,
    get: function get() {
      return _part.noChange;
    }
  });
  Object.defineProperty(_exports, "nothing", {
    enumerable: true,
    get: function get() {
      return _part.nothing;
    }
  });
  Object.defineProperty(_exports, "AttributeCommitter", {
    enumerable: true,
    get: function get() {
      return _parts.AttributeCommitter;
    }
  });
  Object.defineProperty(_exports, "AttributePart", {
    enumerable: true,
    get: function get() {
      return _parts.AttributePart;
    }
  });
  Object.defineProperty(_exports, "BooleanAttributePart", {
    enumerable: true,
    get: function get() {
      return _parts.BooleanAttributePart;
    }
  });
  Object.defineProperty(_exports, "EventPart", {
    enumerable: true,
    get: function get() {
      return _parts.EventPart;
    }
  });
  Object.defineProperty(_exports, "isPrimitive", {
    enumerable: true,
    get: function get() {
      return _parts.isPrimitive;
    }
  });
  Object.defineProperty(_exports, "NodePart", {
    enumerable: true,
    get: function get() {
      return _parts.NodePart;
    }
  });
  Object.defineProperty(_exports, "PropertyCommitter", {
    enumerable: true,
    get: function get() {
      return _parts.PropertyCommitter;
    }
  });
  Object.defineProperty(_exports, "PropertyPart", {
    enumerable: true,
    get: function get() {
      return _parts.PropertyPart;
    }
  });
  Object.defineProperty(_exports, "parts", {
    enumerable: true,
    get: function get() {
      return _render.parts;
    }
  });
  Object.defineProperty(_exports, "render", {
    enumerable: true,
    get: function get() {
      return _render.render;
    }
  });
  Object.defineProperty(_exports, "templateCaches", {
    enumerable: true,
    get: function get() {
      return _templateFactory.templateCaches;
    }
  });
  Object.defineProperty(_exports, "templateFactory", {
    enumerable: true,
    get: function get() {
      return _templateFactory.templateFactory;
    }
  });
  Object.defineProperty(_exports, "TemplateInstance", {
    enumerable: true,
    get: function get() {
      return _templateInstance.TemplateInstance;
    }
  });
  Object.defineProperty(_exports, "createMarker", {
    enumerable: true,
    get: function get() {
      return _template.createMarker;
    }
  });
  Object.defineProperty(_exports, "isTemplatePartActive", {
    enumerable: true,
    get: function get() {
      return _template.isTemplatePartActive;
    }
  });
  Object.defineProperty(_exports, "Template", {
    enumerable: true,
    get: function get() {
      return _template.Template;
    }
  });
  _exports.svg = _exports.html = void 0;

  /**
   * @license
   * Copyright (c) 2017 The Polymer Project Authors. All rights reserved.
   * This code may only be used under the BSD style license found at
   * http://polymer.github.io/LICENSE.txt
   * The complete set of authors may be found at
   * http://polymer.github.io/AUTHORS.txt
   * The complete set of contributors may be found at
   * http://polymer.github.io/CONTRIBUTORS.txt
   * Code distributed by Google as part of the polymer project is also
   * subject to an additional IP rights grant found at
   * http://polymer.github.io/PATENTS.txt
   */

  /**
   *
   * Main lit-html module.
   *
   * Main exports:
   *
   * -  [[html]]
   * -  [[svg]]
   * -  [[render]]
   *
   * @module lit-html
   * @preferred
   */

  /**
   * Do not remove this comment; it keeps typedoc from misplacing the module
   * docs.
   */
  // TODO(justinfagnani): remove line when we get NodePart moving methods
  // IMPORTANT: do not change the property name or the assignment expression.
  // This line will be used in regexes to search for lit-html usage.
  // TODO(justinfagnani): inject version number at build time
  (window['litHtmlVersions'] || (window['litHtmlVersions'] = [])).push('1.0.0');
  /**
   * Interprets a template literal as an HTML template that can efficiently
   * render to and update a container.
   */

  var html = function html(strings) {
    for (var _len = arguments.length, values = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      values[_key - 1] = arguments[_key];
    }

    return new _templateResult.TemplateResult(strings, values, 'html', _defaultTemplateProcessor.defaultTemplateProcessor);
  };
  /**
   * Interprets a template literal as an SVG template that can efficiently
   * render to and update a container.
   */


  _exports.html = html;

  var svg = function svg(strings) {
    for (var _len2 = arguments.length, values = new Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
      values[_key2 - 1] = arguments[_key2];
    }

    return new _templateResult.SVGTemplateResult(strings, values, 'svg', _defaultTemplateProcessor.defaultTemplateProcessor);
  }; //# sourceMappingURL=lit-html.js.map


  _exports.svg = svg;
});