define(["exports", "../../../../../@polymer/polymer/polymer-element.js", "../../core/haxcms-site-store.js", "../../../../../mobx/lib/mobx.module.js"], function (_exports, _polymerElement, _haxcmsSiteStore, _mobxModule) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.SiteActiveFields = void 0;

  /**
   * Copyright 2019 The Pennsylvania State University
   * @license Apache-2.0, see License.md for full text.
   */

  /**
   * `site-active-fields`
   * `Title of the active page in the site`
   *
   * @customElement
   * @polymer
   * @demo demo/index.html
   */
  class SiteActiveFields extends _polymerElement.PolymerElement {
    /**
     * Store the tag name to make it easier to obtain directly.
     * @notice function name must be here for tooling to operate correctly
     */
    static get tag() {
      return "site-active-fields";
    } // render function


    static get template() {
      return _polymerElement.html`
      <style>
        :host {
          display: block;
        }
      </style>
    `;
    }
    /**
     * Props
     */


    static get properties() {
      return {
        fields: {
          type: Object,
          notify: true // @todo support item being passed in

        }
      };
    }

    connectedCallback() {
      super.connectedCallback();
      this.__disposer = (0, _mobxModule.autorun)(() => {
        this.fields = (0, _mobxModule.toJS)(_haxcmsSiteStore.store.activeItemFields);
      });
    }

    disconnectedCallback() {
      super.disconnectedCallback();

      this.__disposer();
    }

  }

  _exports.SiteActiveFields = SiteActiveFields;
  window.customElements.define(SiteActiveFields.tag, SiteActiveFields);
});