define(["exports", "require", "../../../../../@polymer/polymer/polymer-element.js"], function (_exports, _require, _polymerElement) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.SiteDrawer = void 0;
  _require = babelHelpers.interopRequireWildcard(_require);

  /**
   * Copyright 2019 The Pennsylvania State University
   * @license Apache-2.0, see License.md for full text.
   */

  /**
   * `site-drawer`
   * `Basic off canvas drawer element`
   *
   * @customElement
   * @polymer
   * @demo demo/index.html
   */
  class SiteDrawer extends _polymerElement.PolymerElement {
    constructor() {
      super();
      new Promise((res, rej) => _require.default(["../../../../../@polymer/app-layout/app-drawer/app-drawer.js"], res, rej));
      new Promise((res, rej) => _require.default(["../../../../../@polymer/paper-icon-button/paper-icon-button.js"], res, rej));
    }

    static get template() {
      return _polymerElement.html`
      <style>
        app-drawer {
          --app-drawer-width: var(--site-drawer-width, 300px);
          --app-drawer-content-container: {
            background-color: #eeeeee;
          }
          @apply --site-drawer-drawer;
        }
        .drawer-contents {
          height: 100%;
          overflow-y: auto;
          padding: 16px;
          @apply --site-drawer-drawer-content;
        }
        paper-icon-button {
          color: var(--site-drawer-button-color, #ffffff);
          @apply --site-drawer-button;
        }
      </style>
      <paper-icon-button icon="[[icon]]" on-click="toggle"></paper-icon-button>
      <app-drawer align="[[align]]">
        <div class="drawer-contents"><slot></slot></div>
      </app-drawer>
    `;
    }

    toggle(e) {
      this.shadowRoot.querySelector("app-drawer").toggle();
    }

    static get tag() {
      return "site-drawer";
    }

    static get properties() {
      return {
        align: {
          type: String,
          value: "right"
        },
        icon: {
          type: String,
          value: "menu"
        }
      };
    }

  }

  _exports.SiteDrawer = SiteDrawer;
  window.customElements.define(SiteDrawer.tag, SiteDrawer);
});