define(["../../polymer/polymer-legacy.js","../../iron-flex-layout/iron-flex-layout.js","../../polymer/lib/legacy/polymer-fn.js","../../polymer/lib/legacy/polymer.dom.js","../../polymer/lib/utils/html-tag.js","../app-layout-behavior/app-layout-behavior.js","../app-scroll-effects/app-scroll-effects-behavior.js"],function(_polymerLegacy,_ironFlexLayout,_polymerFn,_polymerDom,_htmlTag,_appLayoutBehavior,_appScrollEffectsBehavior){(0,_polymerFn.Polymer)({_template:_htmlTag.html`
    <style>
      :host {
        position: relative;
        display: block;
        transition-timing-function: linear;
        transition-property: -webkit-transform;
        transition-property: transform;
      }

      :host::before {
        position: absolute;
        right: 0px;
        bottom: -5px;
        left: 0px;
        width: 100%;
        height: 5px;
        content: "";
        transition: opacity 0.4s;
        pointer-events: none;
        opacity: 0;
        box-shadow: inset 0px 5px 6px -3px rgba(0, 0, 0, 0.4);
        will-change: opacity;
        @apply --app-header-shadow;
      }

      :host([shadow])::before {
        opacity: 1;
      }

      #background {
        @apply --layout-fit;
        overflow: hidden;
      }

      #backgroundFrontLayer,
      #backgroundRearLayer {
        @apply --layout-fit;
        height: 100%;
        pointer-events: none;
        background-size: cover;
      }

      #backgroundFrontLayer {
        @apply --app-header-background-front-layer;
      }

      #backgroundRearLayer {
        opacity: 0;
        @apply --app-header-background-rear-layer;
      }

      #contentContainer {
        position: relative;
        width: 100%;
        height: 100%;
      }

      :host([disabled]),
      :host([disabled])::after,
      :host([disabled]) #backgroundFrontLayer,
      :host([disabled]) #backgroundRearLayer,
      /* Silent scrolling should not run CSS transitions */
      :host([silent-scroll]),
      :host([silent-scroll])::after,
      :host([silent-scroll]) #backgroundFrontLayer,
      :host([silent-scroll]) #backgroundRearLayer {
        transition: none !important;
      }

      :host([disabled]) ::slotted(app-toolbar:first-of-type),
      :host([disabled]) ::slotted([sticky]),
      /* Silent scrolling should not run CSS transitions */
      :host([silent-scroll]) ::slotted(app-toolbar:first-of-type),
      :host([silent-scroll]) ::slotted([sticky]) {
        transition: none !important;
      }

    </style>
    <div id="contentContainer">
      <slot id="slot"></slot>
    </div>
`,is:"app-header",behaviors:[_appScrollEffectsBehavior.AppScrollEffectsBehavior,_appLayoutBehavior.AppLayoutBehavior],properties:{condenses:{type:Boolean,value:!1},fixed:{type:Boolean,value:!1},reveals:{type:Boolean,value:!1},shadow:{type:Boolean,reflectToAttribute:!0,value:!1}},observers:["_configChanged(isAttached, condenses, fixed)"],_height:0,_dHeight:0,_stickyElTop:0,_stickyElRef:null,_top:0,_progress:0,_wasScrollingDown:!1,_initScrollTop:0,_initTimestamp:0,_lastTimestamp:0,_lastScrollTop:0,get _maxHeaderTop(){return this.fixed?this._dHeight:this._height+5},get _stickyEl(){if(this._stickyElRef)return this._stickyElRef;for(var node,nodes=(0,_polymerDom.dom)(this.$.slot).getDistributedNodes(),i=0;node=nodes[i];i++)if(node.nodeType===Node.ELEMENT_NODE){if(node.hasAttribute("sticky")){this._stickyElRef=node;break}this._stickyElRef||(this._stickyElRef=node)}return this._stickyElRef},_configChanged:function(){this.resetLayout(),this._notifyLayoutChanged()},_updateLayoutStates:function(){if(0!==this.offsetWidth||0!==this.offsetHeight){var scrollTop=this._clampedScrollTop,firstSetup=0===this._height||0===scrollTop,currentDisabled=this.disabled;this._height=this.offsetHeight,this._stickyElRef=null,this.disabled=!0,firstSetup||this._updateScrollState(0,!0),this._mayMove()?this._dHeight=this._stickyEl?this._height-this._stickyEl.offsetHeight:0:this._dHeight=0,this._stickyElTop=this._stickyEl?this._stickyEl.offsetTop:0,this._setUpEffect(),firstSetup?this._updateScrollState(scrollTop,!0):(this._updateScrollState(this._lastScrollTop,!0),this._layoutIfDirty()),this.disabled=currentDisabled}},_updateScrollState:function(scrollTop,forceUpdate){if(0!==this._height){var progress=0,top=0,lastTop=this._top,maxHeaderTop=(this._lastScrollTop,this._maxHeaderTop),dScrollTop=scrollTop-this._lastScrollTop,absDScrollTop=Math.abs(dScrollTop),isScrollingDown=scrollTop>this._lastScrollTop,now=performance.now();if(this._mayMove()&&(top=this._clamp(this.reveals?lastTop+dScrollTop:scrollTop,0,maxHeaderTop)),scrollTop>=this._dHeight&&(top=this.condenses&&!this.fixed?Math.max(this._dHeight,top):top,this.style.transitionDuration="0ms"),this.reveals&&!this.disabled&&absDScrollTop<100&&((now-this._initTimestamp>300||this._wasScrollingDown!==isScrollingDown)&&(this._initScrollTop=scrollTop,this._initTimestamp=now),scrollTop>=maxHeaderTop))if(Math.abs(this._initScrollTop-scrollTop)>30||absDScrollTop>10){isScrollingDown&&scrollTop>=maxHeaderTop?top=maxHeaderTop:!isScrollingDown&&scrollTop>=this._dHeight&&(top=this.condenses&&!this.fixed?this._dHeight:0);var scrollVelocity=dScrollTop/(now-this._lastTimestamp);this.style.transitionDuration=this._clamp((top-lastTop)/scrollVelocity,0,300)+"ms"}else top=this._top;progress=0===this._dHeight?scrollTop>0?1:0:top/this._dHeight,forceUpdate||(this._lastScrollTop=scrollTop,this._top=top,this._wasScrollingDown=isScrollingDown,this._lastTimestamp=now),(forceUpdate||progress!==this._progress||lastTop!==top||0===scrollTop)&&(this._progress=progress,this._runEffects(progress,top),this._transformHeader(top))}},_mayMove:function(){return this.condenses||!this.fixed},willCondense:function(){return this._dHeight>0&&this.condenses},isOnScreen:function(){return 0!==this._height&&this._top<this._height},isContentBelow:function(){return 0===this._top?this._clampedScrollTop>0:this._clampedScrollTop-this._maxHeaderTop>=0},_transformHeader:function(y){this.translate3d(0,-y+"px",0),this._stickyEl&&this.translate3d(0,this.condenses&&y>=this._stickyElTop?Math.min(y,this._dHeight)-this._stickyElTop+"px":0,0,this._stickyEl)},_clamp:function(v,min,max){return Math.min(max,Math.max(min,v))},_ensureBgContainers:function(){this._bgContainer||(this._bgContainer=document.createElement("div"),this._bgContainer.id="background",this._bgRear=document.createElement("div"),this._bgRear.id="backgroundRearLayer",this._bgContainer.appendChild(this._bgRear),this._bgFront=document.createElement("div"),this._bgFront.id="backgroundFrontLayer",this._bgContainer.appendChild(this._bgFront),(0,_polymerDom.dom)(this.root).insertBefore(this._bgContainer,this.$.contentContainer))},_getDOMRef:function(id){switch(id){case"backgroundFrontLayer":return this._ensureBgContainers(),this._bgFront;case"backgroundRearLayer":return this._ensureBgContainers(),this._bgRear;case"background":return this._ensureBgContainers(),this._bgContainer;case"mainTitle":return(0,_polymerDom.dom)(this).querySelector("[main-title]");case"condensedTitle":return(0,_polymerDom.dom)(this).querySelector("[condensed-title]")}return null},getScrollState:function(){return{progress:this._progress,top:this._top}}})});