import{html,PolymerElement}from"../../@polymer/polymer/polymer-element.js";import{SchemaBehaviors}from"../schema-behaviors/schema-behaviors.js";class ImageCompareSlider extends(SchemaBehaviors(PolymerElement)){constructor(){super(),import("../user-action/user-action.js"),import("../../@polymer/iron-image/iron-image.js"),import("../../@polymer/paper-slider/paper-slider.js")}static get template(){return html`
      <style>
        :host {
          display: inline-flex;
          width: 100%;
          @apply --image-compare-slider;
        }
        :host > div,
        :host #container,
        :host #top {
          width: 100%;
        }
        :host #container {
          background-size: cover;
          overflow: visible;
          @apply --image-compare-slider-container;
        }
        :host #top {
          background-size: auto 100%;
          overflow: hidden;
        }
        :host #slider {
          width: calc(100% + 30px);
          margin-left: -15px;
          @apply --image-compare-slider-control;
        }
      </style>
      <div>
        <h2>[[title]]</h2>
        <div id="container" style$="background-image: url([[bottomSrc]]);">
          <div id="top" style$="background-image: url([[topSrc]]);"></div>
        </div>
        <user-action track="click">
          <paper-slider id="slider" value="50"></paper-slider>
        </user-action>
        <div></div>
      </div>
    `}static get tag(){return"image-compare-slider"}static get observers(){return["_setStyles(width,height,sliderPercent)"]}static get properties(){let props={title:{type:String},topSrc:{type:String,observer:"_updateAspect"},opacity:{type:Boolean,value:!1},bottomSrc:{type:String}};return super.properties&&(props=Object.assign(props,super.properties)),props}static get haxProperties(){return{canScale:!0,canPosition:!0,canEditSource:!1,gizmo:{title:"Image comparison",description:"Simple element to allow one image to swipe over top of the other.",icon:"image:compare",color:"orange",groups:["Image","Media"],handles:[{type:"image",source:"bottomSrc",source2:"topSrc",title:"title"}],meta:{author:"LRNWebComponents"}},settings:{quick:[{property:"title",title:"Title",description:"The title of the element",inputMethod:"textfield",icon:"editor:title"},{property:"opacity",title:"Slider Behavior",description:"Do you want the slider to wipe the top image across the bottom one (default), or to adjust the opacity of the top image?",inputMethod:"select",options:{false:"wipe across",true:"adjust opacity"},icon:"image:compare"}],configure:[{property:"title",title:"Title",description:"The title of the element",inputMethod:"textfield"},{property:"bottomSrc",title:"Bottom image",description:"The base image to swipe over",inputMethod:"haxupload",validationType:"url"},{property:"topSrc",title:"Top image",description:"The top image that swipes over",inputMethod:"haxupload",validationType:"url"}],advanced:[]}}}ready(){super.ready(),this._updateAspect(),this._slide(),this.shadowRoot.querySelector("#slider").addEventListener("immediate-value-changed",e=>{this._slide()})}_slide(){!1===this.opacity?this.shadowRoot.querySelector("#top").style.width=this.shadowRoot.querySelector("#slider").immediateValue+"%":this.shadowRoot.querySelector("#top").style.opacity=this.shadowRoot.querySelector("#slider").immediateValue/100}_updateAspect(){let img=document.createElement("img"),el=this.shadowRoot.querySelector("#top"),getAspect=img=>{el.style.paddingTop=100*img.height/img.width+"%"};this.__aspect="75",img.setAttribute("src",this.topSrc),void 0!==img.height&&img.height>0?getAspect(img):img.addEventListener("load",function(){getAspect(img)})}}window.customElements.define(ImageCompareSlider.tag,ImageCompareSlider);export{ImageCompareSlider};