define(["../../../../@polymer/polymer/lib/elements/custom-style.js", "../../../vaadin-lumo-styles/color.js", "../../../vaadin-lumo-styles/sizing.js", "../../../vaadin-lumo-styles/spacing.js", "../../../vaadin-lumo-styles/style.js"], function (_customStyle, _color, _sizing, _spacing, _style) {
  "use strict";

  var $_documentContainer = document.createElement('template');
  $_documentContainer.innerHTML = "<dom-module id=\"lumo-progress-bar\" theme-for=\"vaadin-progress-bar\">\n  <template>\n    <style>\n      :host {\n        height: calc(var(--lumo-size-l) / 10);\n        margin: var(--lumo-space-s) 0;\n      }\n\n      [part=\"bar\"] {\n        border-radius: var(--lumo-border-radius);\n        background-color: var(--lumo-contrast-10pct);\n      }\n\n      [part=\"value\"] {\n        border-radius: var(--lumo-border-radius);\n        background-color: var(--lumo-primary-color);\n        /* Use width instead of transform to preserve border radius */\n        transform: none;\n        width: calc(var(--vaadin-progress-value) * 100%);\n        will-change: width;\n        transition: 0.1s width linear;\n      }\n\n      /* Indeterminate mode */\n\n      :host([indeterminate]) [part=\"value\"] {\n        --lumo-progress-indeterminate-progress-bar-background: linear-gradient(to right, var(--lumo-primary-color-10pct) 10%, var(--lumo-primary-color));\n        --lumo-progress-indeterminate-progress-bar-background-reverse: linear-gradient(to left, var(--lumo-primary-color-10pct) 10%, var(--lumo-primary-color));\n        width: 100%;\n        background-color: transparent !important;\n        background-image: var(--lumo-progress-indeterminate-progress-bar-background);\n        opacity: 0.75;\n        will-change: transform;\n        animation: vaadin-progress-slide 1.6s infinite cubic-bezier(.645, .045, .355, 1), vaadin-progress-scale 1.6s infinite cubic-bezier(.645, .045, .355, 1);\n      }\n\n      @keyframes vaadin-progress-slide {\n        0% {\n          transform-origin: 0% 0%;\n        }\n\n        50% {\n          transform-origin: 100% 0%;\n          background-image: var(--lumo-progress-indeterminate-progress-bar-background);\n        }\n\n        50.1% {\n          transform-origin: 100% 0%;\n          background-image: var(--lumo-progress-indeterminate-progress-bar-background-reverse);\n        }\n\n        100% {\n          transform-origin: 0% 0%;\n          background-image: var(--lumo-progress-indeterminate-progress-bar-background-reverse);\n        }\n      }\n\n      @keyframes vaadin-progress-scale {\n        0% { transform: scaleX(0.015); }\n        25% { transform: scaleX(0.4); }\n        50% { transform: scaleX(0.015); }\n        50.1% { transform: scaleX(0.015); }\n        75% { transform: scaleX(0.4); }\n        100% { transform: scaleX(0.015); }\n      }\n\n      :host(:not([aria-valuenow])) [part=\"value\"]::before,\n      :host([indeterminate]) [part=\"value\"]::before {\n        content: \"\";\n        display: block;\n        width: 100%;\n        height: 100%;\n        border-radius: inherit;\n        background-color: var(--lumo-primary-color);\n        will-change: opacity;\n        animation: vaadin-progress-pulse3 1.6s infinite cubic-bezier(.645, .045, .355, 1);\n      }\n\n      @keyframes vaadin-progress-pulse3 {\n        0% { opacity: 1; }\n        10% { opacity: 0; }\n        40% { opacity: 0; }\n        50% { opacity: 1; }\n        50.1% { opacity: 1; }\n        60% { opacity: 0; }\n        90% { opacity: 0; }\n        100% { opacity: 1; }\n      }\n\n      /* Contrast color */\n\n      :host([theme~=\"contrast\"]) [part=\"value\"],\n      :host([theme~=\"contrast\"]) [part=\"value\"]::before {\n        background-color: var(--lumo-contrast-80pct);\n        --lumo-progress-indeterminate-progress-bar-background: linear-gradient(to right, var(--lumo-contrast-5pct) 10%, var(--lumo-contrast-80pct));\n        --lumo-progress-indeterminate-progress-bar-background-reverse: linear-gradient(to left, var(--lumo-contrast-5pct) 10%, var(--lumo-contrast-60pct));\n      }\n\n      /* Error color */\n\n      :host([theme~=\"error\"]) [part=\"value\"],\n      :host([theme~=\"error\"]) [part=\"value\"]::before {\n        background-color: var(--lumo-error-color);\n        --lumo-progress-indeterminate-progress-bar-background: linear-gradient(to right, var(--lumo-error-color-10pct) 10%, var(--lumo-error-color));\n        --lumo-progress-indeterminate-progress-bar-background-reverse: linear-gradient(to left, var(--lumo-error-color-10pct) 10%, var(--lumo-error-color));\n      }\n\n      /* Primary color */\n\n      :host([theme~=\"success\"]) [part=\"value\"],\n      :host([theme~=\"success\"]) [part=\"value\"]::before {\n        background-color: var(--lumo-success-color);\n        --lumo-progress-indeterminate-progress-bar-background: linear-gradient(to right, var(--lumo-success-color-10pct) 10%, var(--lumo-success-color));\n        --lumo-progress-indeterminate-progress-bar-background-reverse: linear-gradient(to left, var(--lumo-success-color-10pct) 10%, var(--lumo-success-color));\n      }\n    </style>\n  </template>\n</dom-module><custom-style>\n  <style>\n    @keyframes vaadin-progress-pulse3 {\n      0% { opacity: 1; }\n      10% { opacity: 0; }\n      40% { opacity: 0; }\n      50% { opacity: 1; }\n      50.1% { opacity: 1; }\n      60% { opacity: 0; }\n      90% { opacity: 0; }\n      100% { opacity: 1; }\n    }\n  </style>\n</custom-style>";
  document.head.appendChild($_documentContainer.content);
  /* Safari fails to declare animations for pseudo elements inside a shadow DOM */

  /*
    FIXME(polymer-modulizer): the above comments were extracted
    from HTML and may be out of place here. Review them and
    then delete this comment!
  */

  ;
});