define(["../../../vaadin-lumo-styles/color.js", "../../../vaadin-lumo-styles/sizing.js", "../../../vaadin-lumo-styles/spacing.js", "../../../vaadin-lumo-styles/style.js"], function (_color, _sizing, _spacing, _style) {
  "use strict";

  var $_documentContainer = document.createElement('template');
  $_documentContainer.innerHTML = "<dom-module id=\"lumo-split-layout\" theme-for=\"vaadin-split-layout\">\n  <template>\n    <style>\n      [part=\"splitter\"] {\n        min-width: var(--lumo-space-s);\n        min-height: var(--lumo-space-s);\n        background-color: var(--lumo-contrast-5pct);\n        transition: 0.1s background-color;\n      }\n\n      [part=\"handle\"] {\n        display: flex;\n        align-items: center;\n        justify-content: center;\n        width: var(--lumo-size-m);\n        height: var(--lumo-size-m);\n      }\n\n      [part=\"handle\"]::after {\n        content: \"\";\n        display: block;\n        width: 4px;\n        height: 100%;\n        max-width: 100%;\n        max-height: 100%;\n        border-radius: var(--lumo-border-radius);\n        background-color: var(--lumo-contrast-30pct);\n        transition: 0.1s opacity, 0.1s background-color;\n      }\n\n      :host([orientation=\"vertical\"]) [part=\"handle\"]::after {\n        width: 100%;\n        height: 4px;\n      }\n\n      /* Hover style */\n\n      [part=\"splitter\"]:hover [part=\"handle\"]::after {\n        background-color: var(--lumo-contrast-40pct);\n      }\n\n      /* Disable hover for touch devices */\n      @media (pointer: coarse) {\n        [part=\"splitter\"]:hover [part=\"handle\"]::after {\n          background-color: var(--lumo-contrast-30pct);\n        }\n      }\n\n      /* Active style */\n\n      [part=\"splitter\"]:active [part=\"handle\"]::after {\n        background-color: var(--lumo-contrast-50pct);\n      }\n\n      /* Small/minimal */\n\n      :host([theme~=\"small\"]) > [part=\"splitter\"] {\n        border-left: 1px solid var(--lumo-contrast-10pct);\n        border-top: 1px solid var(--lumo-contrast-10pct);\n      }\n\n      :host([theme~=\"small\"]) > [part=\"splitter\"],\n      :host([theme~=\"minimal\"]) > [part=\"splitter\"] {\n        min-width: 0;\n        min-height: 0;\n        background-color: transparent;\n      }\n\n      :host([theme~=\"small\"]) > [part=\"splitter\"]::after,\n      :host([theme~=\"minimal\"]) > [part=\"splitter\"]::after {\n        content: \"\";\n        position: absolute;\n        top: -4px;\n        right: -4px;\n        bottom: -4px;\n        left: -4px;\n      }\n\n      :host([theme~=\"small\"]) > [part=\"splitter\"] > [part=\"handle\"]::after,\n      :host([theme~=\"minimal\"]) > [part=\"splitter\"] > [part=\"handle\"]::after {\n        opacity: 0;\n      }\n\n      :host([theme~=\"small\"]) > [part=\"splitter\"]:hover > [part=\"handle\"]::after,\n      :host([theme~=\"small\"]) > [part=\"splitter\"]:active > [part=\"handle\"]::after,\n      :host([theme~=\"minimal\"]) > [part=\"splitter\"]:hover > [part=\"handle\"]::after,\n      :host([theme~=\"minimal\"]) > [part=\"splitter\"]:active > [part=\"handle\"]::after {\n        opacity: 1;\n      }\n    </style>\n  </template>\n</dom-module>";
  document.head.appendChild($_documentContainer.content);
});