import{html,PolymerElement}from"../../@polymer/polymer/polymer-element.js";import{dom}from"../../@polymer/polymer/lib/legacy/polymer.dom.js";import*as async from"../../@polymer/polymer/lib/utils/async.js";import"./lib/map-layer.js";import"./lib/map-area.js";import"./lib/map-styles.js";class WebMap extends PolymerElement{static get template(){return html`
      <!-- use the leaflet-styles style module -->
      <style include="map-styles">
        /* make sure the map element doesn't get selected and styled by document styles */
        :host {
          display: inline-block !important;
          position: relative !important;
        }
        /* try to constrain the map and the leaflet div#map to the size of the container */
        :host,
        :host #map {
          max-width: 100%;
          min-width: 100%;
        }
        /* this is a hack for shady DOM, as max-width messes with Leaflet tiles */
        :host img {
          max-width: none !important;
        }
        #map:focus {
          outline: 2px double lightskyblue;
        }
      </style>
      <!-- giving the map div a tabindex allows the map to display its focus. -->
      <!-- see the #map:focus selector in styles, above. -->
      <div id="map" tabindex="0"></div>
      <slot></slot>
    `}static get tag(){return"web-map"}factoryImpl(width,height,lat,lon,zoom,projection,controls){this.width=width,this.height=height,this.lat=lat||this.lat,this.lon=lon||this.lon,this.zoom=zoom||this.zoom,this.projection=projection||"OSMTILE",this.controls=controls||this.controls}static get properties(){return{lat:{type:Number,value:0,reflectToAttribute:!0},lon:{type:Number,value:0,reflectToAttribute:!0},zoom:{type:Number,value:0,reflectToAttribute:!0},projection:{type:String,value:"OSMTILE",reflectToAttribute:!1},width:{type:Number,value:null,reflectToAttribute:!0},height:{type:Number,value:null,reflectToAttribute:!0},layers:{type:Object,value(){return this.getElementsByTagName("layer-")}},areas:{type:Object,value(){return this.getElementsByTagName("area")}},controls:{type:Boolean,reflectToAttribute:!0}}}static get observers(){return["_widthChanged(width)","_heightChanged(height)","_toggleControls(controls)"]}_toggleControls(controls){if(this._map)if(controls){this._zoomControl=L.control.zoom().addTo(this._map),this._layerControl=M.mapMlLayerControl(null,{collapsed:!0}).addTo(this._map);for(var i=0;i<this.layers.length;i++)this.layers[i].hidden||(this._layerControl.addOverlay(this.layers[i]._layer,this.layers[i].label),this._map.on("moveend",this.layers[i]._validateDisabled,this.layers[i]),this.layers[i]._layerControl=this._layerControl)}else this._map.removeControl(this._layerControl),this._map.removeControl(this._zoomControl)}_widthChanged(width){this.style.width=width+"px",this.$.map.style.width=width+"px",this._map&&this._map.invalidateSize(!1)}_heightChanged(height){this.style.height=height+"px",this.$.map.style.height=height+"px",this._map&&this._map.invalidateSize(!1)}zoomTo(lat,lon,zoom){zoom=zoom||this.zoom;var location=new L.LatLng(lat,lon);this._map.setView(location,zoom),this.zoom=zoom,this.lat=location.lat,this.lon=location.lng}_updateMapCenter(){this.lat=this._map.getCenter().lat,this.lon=this._map.getCenter().lng,this.zoom=this._map.getZoom()}ready(){if(super.ready(),L.Icon.Default.imagePath=function(){var i,len,src,path,imp=document.querySelector('link[rel="import"][href*="web-map.html"]'),scripts=(imp?imp.import:document).getElementsByTagName("script"),leafletRe=/[\/^]leaflet[\-\._]?([\w\-\._]*)\.js\??/;for(i=0,len=scripts.length;i<len;i++)if((src=scripts[i].src).match(leafletRe))return((path=src.split(leafletRe)[0])?path+"/":"")+"images"}(),this.hasAttribute("name")){var name=this.getAttribute("name");name&&(this.poster=document.querySelector('img[usemap="#'+name+'"]'),this.poster&&(L.Browser.gecko&&this.poster.removeAttribute("usemap"),dom(this.$.map).appendChild(this.poster)))}}disconnectedCallback(){this._removeEvents(),super.disconnectedCallback()}connectedCallback(){super.connectedCallback(),async.microTask.run(()=>{var s=window.getComputedStyle(this),wpx=s.width,hpx=s.height,w=parseInt(wpx.replace("px","")),h=parseInt(hpx.replace("px",""));if(""!==wpx&&""!==hpx&&(this.width&&this.width===w?this.$.map.style.width=this.width+"px":(this.$.map.style.width=wpx,this.width=w),this.height&&this.height===h?this.$.map.style.height=this.height+"px":(this.$.map.style.height=h,this.height=h),!this._map)){this._map=L.map(this.$.map,{center:new L.LatLng(this.lat,this.lon),projection:this.projection,crs:M[this.projection],zoom:this.zoom,zoomControl:!1,fadeAnimation:!0}),this.controls&&(this._layerControl=M.mapMlLayerControl(null,{collapsed:!0}).addTo(this._map),this._zoomControl=L.control.zoom().addTo(this._map)),this._attributionControl=this._map.attributionControl.setPrefix('<a href="https://www.w3.org/community/maps4html/" title="W3C Maps4HTML Community Group">Maps4HTML</a> | <a href="http://leafletjs.com" title="A JS library for interactive maps">Leaflet</a>');for(var i=0;i<this.layers.length;i++)this.layers[i]._attachedToMap();for(i=0;i<this.areas.length;i++)this.areas[i]._attachedToMap();this.layers[0]&&void 0===this.layers[0]._layer.error&&this.layers[0]._layer._extent&&this.poster&&(this.poster.style.display="none"),this._setUpEvents(),this.dispatchEvent(new CustomEvent("load",{bubbles:!0,cancelable:!0,composed:!0,detail:{target:this}}))}},10)}_removeEvents(){this._map&&(this._map.off("preclick click dblclick mousemove mouseover mouseout mousedown mouseup contextmenu",!1,this),this._map.off("load movestart move moveend zoomstart zoom zoomend",!1,this))}_setUpEvents(){this._map.on("load",function(){this.dispatchEvent(new CustomEvent("load",{bubbles:!0,cancelable:!0,composed:!0,detail:{target:this}}))},this),this._map.on("preclick",function(e){this.dispatchEvent(new CustomEvent("preclick",{bubbles:!0,cancelable:!0,composed:!0,detail:{lat:e.latlng.lat,lon:e.latlng.lng,x:e.containerPoint.x,y:e.containerPoint.y}}))},this),this._map.on("click",function(e){this.dispatchEvent(new CustomEvent("click",{bubbles:!0,cancelable:!0,composed:!0,detail:{lat:e.latlng.lat,lon:e.latlng.lng,x:e.containerPoint.x,y:e.containerPoint.y}}))},this),this._map.on("dblclick",function(e){this.dispatchEvent(new CustomEvent("dblclick",{bubbles:!0,cancelable:!0,composed:!0,detail:{lat:e.latlng.lat,lon:e.latlng.lng,x:e.containerPoint.x,y:e.containerPoint.y}}))},this),this._map.on("mousemove",function(e){this.dispatchEvent(new CustomEvent("mousemove",{bubbles:!0,cancelable:!0,composed:!0,detail:{lat:e.latlng.lat,lon:e.latlng.lng,x:e.containerPoint.x,y:e.containerPoint.y}}))},this),this._map.on("mouseover",function(e){this.dispatchEvent(new CustomEvent("mouseover",{bubbles:!0,cancelable:!0,composed:!0,detail:{lat:e.latlng.lat,lon:e.latlng.lng,x:e.containerPoint.x,y:e.containerPoint.y}}))},this),this._map.on("mouseout",function(e){this.dispatchEvent(new CustomEvent("mouseout",{bubbles:!0,cancelable:!0,composed:!0,detail:{lat:e.latlng.lat,lon:e.latlng.lng,x:e.containerPoint.x,y:e.containerPoint.y}}))},this),this._map.on("mousedown",function(e){this.dispatchEvent(new CustomEvent("mousedown",{bubbles:!0,cancelable:!0,composed:!0,detail:{lat:e.latlng.lat,lon:e.latlng.lng,x:e.containerPoint.x,y:e.containerPoint.y}}))},this),this._map.on("mouseup",function(e){this.dispatchEvent(new CustomEvent("mouseup",{bubbles:!0,cancelable:!0,composed:!0,detail:{lat:e.latlng.lat,lon:e.latlng.lng,x:e.containerPoint.x,y:e.containerPoint.y}}))},this),this._map.on("contextmenu",function(e){this.dispatchEvent(new CustomEvent("contextmenu",{bubbles:!0,cancelable:!0,composed:!0,detail:{lat:e.latlng.lat,lon:e.latlng.lng,x:e.containerPoint.x,y:e.containerPoint.y}}))},this),this._map.on("movestart",function(){this._updateMapCenter(),this.dispatchEvent(new CustomEvent("movestart",{bubbles:!0,cancelable:!0,composed:!0,detail:{target:this}}))},this),this._map.on("move",function(){this._updateMapCenter(),this.dispatchEvent(new CustomEvent("move",{bubbles:!0,cancelable:!0,composed:!0,detail:{target:this}}))},this),this._map.on("moveend",function(){this._updateMapCenter(),this.dispatchEvent(new CustomEvent("moveend",{bubbles:!0,cancelable:!0,composed:!0,detail:{target:this}}))},this),this._map.on("zoomstart",function(){this._updateMapCenter(),this.dispatchEvent(new CustomEvent("zoomstart",{bubbles:!0,cancelable:!0,composed:!0,detail:{target:this}}))},this),this._map.on("zoom",function(){this._updateMapCenter(),this.dispatchEvent(new CustomEvent("zoom",{bubbles:!0,cancelable:!0,composed:!0,detail:{target:this}}))},this),this._map.on("zoomend",function(){this._updateMapCenter(),this.dispatchEvent(new CustomEvent("zoomend",{bubbles:!0,cancelable:!0,composed:!0,detail:{target:this}}))},this)}}window.customElements.define(WebMap.tag,WebMap);export{WebMap};