export default Compiler;function Compiler(locales,formats,pluralFn){this.locales=locales,this.formats=formats,this.pluralFn=pluralFn}function StringFormat(id){this.id=id}function PluralFormat(id,useOrdinal,offset,options,pluralFn){this.id=id,this.useOrdinal=useOrdinal,this.offset=offset,this.options=options,this.pluralFn=pluralFn}function PluralOffsetString(id,offset,numberFormat,string){this.id=id,this.offset=offset,this.numberFormat=numberFormat,this.string=string}function SelectFormat(id,options){this.id=id,this.options=options}Compiler.prototype.compile=function(ast){return this.pluralStack=[],this.currentPlural=null,this.pluralNumberFormat=null,this.compileMessage(ast)},Compiler.prototype.compileMessage=function(ast){if(!ast||"messageFormatPattern"!==ast.type)throw new Error('Message AST is not of type: "messageFormatPattern"');var i,len,element,elements=ast.elements,pattern=[];for(i=0,len=elements.length;i<len;i+=1)switch((element=elements[i]).type){case"messageTextElement":pattern.push(this.compileMessageText(element));break;case"argumentElement":pattern.push(this.compileArgument(element));break;default:throw new Error("Message element does not have a valid type")}return pattern},Compiler.prototype.compileMessageText=function(element){return this.currentPlural&&/(^|[^\\])#/g.test(element.value)?(this.pluralNumberFormat||(this.pluralNumberFormat=new Intl.NumberFormat(this.locales)),new PluralOffsetString(this.currentPlural.id,this.currentPlural.format.offset,this.pluralNumberFormat,element.value)):element.value.replace(/\\#/g,"#")},Compiler.prototype.compileArgument=function(element){var format=element.format;if(!format)return new StringFormat(element.id);var options,formats=this.formats,locales=this.locales,pluralFn=this.pluralFn;switch(format.type){case"numberFormat":return options=formats.number[format.style],{id:element.id,format:new Intl.NumberFormat(locales,options).format};case"dateFormat":return options=formats.date[format.style],{id:element.id,format:new Intl.DateTimeFormat(locales,options).format};case"timeFormat":return options=formats.time[format.style],{id:element.id,format:new Intl.DateTimeFormat(locales,options).format};case"pluralFormat":return options=this.compileOptions(element),new PluralFormat(element.id,format.ordinal,format.offset,options,pluralFn);case"selectFormat":return options=this.compileOptions(element),new SelectFormat(element.id,options);default:throw new Error("Message element does not have a valid format type")}},Compiler.prototype.compileOptions=function(element){var i,len,option,format=element.format,options=format.options,optionsHash={};for(this.pluralStack.push(this.currentPlural),this.currentPlural="pluralFormat"===format.type?element:null,i=0,len=options.length;i<len;i+=1)optionsHash[(option=options[i]).selector]=this.compileMessage(option.value);return this.currentPlural=this.pluralStack.pop(),optionsHash},StringFormat.prototype.format=function(value){return value||"number"==typeof value?"string"==typeof value?value:String(value):""},PluralFormat.prototype.getOption=function(value){var options=this.options;return options["="+value]||options[this.pluralFn(value-this.offset,this.useOrdinal)]||options.other},PluralOffsetString.prototype.format=function(value){var number=this.numberFormat.format(value-this.offset);return this.string.replace(/(^|[^\\])#/g,"$1"+number).replace(/\\#/g,"#")},SelectFormat.prototype.getOption=function(value){var options=this.options;return options[value]||options.other};